// code by jph

matrix<float>           pPos(3,3,"eye");                // homogeneous transformation from world to globe (pPos*cPos is the global position of robot)
matrix<float>           pInv(3,3,"eye");                // homogeneous transformation from world to globe (pPos*cPos is the global position of robot)
matrix<float>           cPos(3,3,"eye");                // homogeneous transformation from local to world
matrix<float>           cInv;                           // homogeneous transformation from world to local (cInv is inverse of cPos)
matrix<float>           cStopped(3,1);                  // world coordinates of position of last active motion
matrix<float>           cTarget(3,1);                   // world coordinates

#define                 cPARAM                  500     // 5*5*5*4
float                   cParam[cPARAM];                 // lookup table to speed up the process
linked<matrix<int> >    cOptimize;                      // not used very well
                        
#define                 cTERRAIN_NOGO           0x00
#define                 cTERRAIN_FREE           0x01
#define                 cTERRAIN_EOOB           0x02    // extra ordinary obstacle
#define                 cTERRAIN_AURA           0x1a    //                     11010
#define                 cTERRAIN_OBST           0x1c    //                     11100
#define                 cTERRAIN_WALL           0x1f    // max mask as well -> 11111
#define                 cTERRAIN_STUB           0x20    // 0010 0000

#define                 cTERRAIN                360000  // 600 600
#define                 cTERRAIN_JOIN           0.08f
#define                 cTERRAIN_RANGEMAX       4.50f   // distance until to insert "free" terrain
#define                 cTERRAIN_OFFSET         0.07f   // is to clear old laser points
#define                 cTERRAIN_HANOI          0.06f
#define                 cTERRAIN_BLOCK          5.00f
                                              
int                     cTerrain[cTERRAIN];             // density function: high in regions close to obstacles, 0 for unexplored terrain
SDL_Surface*            cTerrainDraw;                   // visualization of density function (just amplifies the values)
SDL_Surface*            cTerrainStub;                   // this can be used for anything, and should be cleared (all NULL) before use
SDL_Surface*            cTerrainTria;                   // holds perceived data for updating density
SDL_Surface*            cTerrainDiff;                   // to detect motion
SDL_Surface*            cTerrainHoly;                   // required when human approach the robot (to free their old geometry)
matrix<float>           cTerrainBlock(3,4);

#define                 cBLIT_RADIUS            1.25f

linked<matrix<float> >  cLaserList;                     // this better be in cPos-like coordinates
matrix<int>             cLaserSpot(jLASER_SPOTS,4);     // contains only small segments that might id as human
#define                 cMOVES_WIDTH_MIN        3       // depends on the sampling rate
#define                 cMOVES_WIDTH_MAX        12      // max width to detect human
#define                 cMOVES_SIZE1            40
#define                 cMOVES_MASK             0x08
matrix<float>           cMoves(3,cMOVES_SIZE1);         // needs at most twice as much space as cLaserSpot
matrix<float>           cMovesAura(3,4);
matrix<float>           cStone;
                        
#define                 cDENSITY                90000   // cTERRAIN/4
#define                 cDENSITY_RANGEMAX       4.00f
#define                 cDENSITY_OFFSET         0.32f   // when Marsokhod is not in the game
//#define                 cDENSITY_OFFSET         (0.32f+0.12f*mMover->active)   // contains + 2cm uncertanty from density seed
                        
int                     cDensity[cTERRAIN];             // density function: high in regions close to obstacles, 0 for unexplored terrain
int                     cDensitySeed[cDENSITY];         // this is const
SDL_Surface*            cDensityDraw;                   // constructor and visualization of density function
                        
#define                 cROUTE_QUALITY          300
#define                 cROUTEVALID             0.08f   // old routing is valid if new target is only
#define                 cROUTE_FREQUENT         jTic[jTOC_NEXT_NAVIGATION]=MIN(jTic[jTOC_NEXT_NAVIGATION],jTic[jTOC_LAST_SENSORS]+800)
                        
float                   cRouteDist[cTERRAIN];           // reserve space for routing
int                     cRoutePred[cTERRAIN];           // reserve space for routing
int                     cRouteMask[cTERRAIN];           // reserve space for routing
matrix<float>           cTargetOld(3,1);                // point of last routing source

SDL_Surface*            cMap;                           // current view with respect to world
#define                 cATLAS                  8192    // max wall pixels per local map view
int                     cAtlasInd[cATLAS];
int                     cAtlasNum=0;
#define                 cDRAIN                  4096    // max red pixels per local map view
int                     cDrainInd[cDRAIN];
int                     cDrainNum=0;

SDL_Surface*            cProfileDraw;                   // for pictures of floor 
                        
#define                 cPROFILE_RANGEMIN       0.7f
#define                 cPROFILE_RANGEMAX       1.2f
#define                 cPROFILE_RANGERES       15
#define                 cPROFILE_ALPHA          0xb4
                        
linked<jMoviton*>       pStone;
linked<jMoviton*>       pMoves;

jMoviton*               pMover;                         // moving master, never null! (choose pMover=jMover if no other option)

#define                 pGainFwd                3.00f
#define                 pGainInt                0.45f
#define                 pGainPos                0.10f
#define                 pGainAng                0.75f
#define                 pGainOme                0.15f


#define                 cMOVER_COLOR(tok)       0xff7f7f7f+0x00202080*(jTic[jTOC_LAST_SENSORS]<tok->stamp+jROLLOUT)
#define                 pMOVER_COLOR(tok)       0xffffffff-0x000000ff*(tok==pMover)

#define                 cSOLID                  200017  // should be prime number, e.g. 101111, 200017
#define                 cSOLID_OFFSET           10000   // 10000 are 100 meter

int cSolidHash(matrix<int> mat) { return (mat.data[0]+mat.data[1])%cSOLID; }
jset<matrix<int> > cSolid(cSOLID,cSolidHash);

#define                 cDISPLAY                3
#define                 cDISPLAY_GEOGRAPHY      0
#define                 cDISPLAY_ROUTING        1
#define                 cDISPLAY_ATLAS          2

int                     cDisplay=cDISPLAY_GEOGRAPHY;
// END: globals

#include "cslam.cpp"
#include "mflow.cpp"
#include "mslam.cpp"

void cInit() {
  jDEBUG("cInit")
  int c1,c2,c3,cnt=0;
  cTerrainDraw=SDL_CREATERGBSURFACE(jMAP_W,jMAP_H);
  cTerrainStub=SDL_CREATERGBSURFACE(jMAP_W,jMAP_H);
  cTerrainTria=SDL_CREATERGBSURFACE(jMAP_W,jMAP_H);
  cTerrainDiff=SDL_CREATERGBSURFACE(jMAP_W,jMAP_H);
  cTerrainHoly=SDL_CREATERGBSURFACE(jMAP_W,jMAP_H);
  cDensityDraw=SDL_CREATERGBSURFACE(jMAP_W,jMAP_H);
  cProfileDraw=SDL_CREATERGBSURFACE(jMAP_W,jMAP_H);
  cMap        =SDL_CREATERGBSURFACE(jMAP_W,jMAP_H);
  pPos.data[6]=21.70; // put robot at typical starting position
  pPos.data[7]=24.75;
  pInv.data[6]=-pPos.data[6];
  pInv.data[7]=-pPos.data[7];
  cReset(true);
  jTic[jTOC_LAST_SLAM]=jCLOCK_FUNC;  
  cnt=0;
  for (c1=0;c1<cTERRAIN;c1+=2) {
    if (!(c1%jMAP_W))
      c1+=jMAP_W;
    cDensitySeed[cnt++]=c1;
  }
  cTerrainBlock.data[0*3+0]= cTERRAIN_BLOCK;
  cTerrainBlock.data[0*3+1]= jLASER_OFFSET+cTERRAIN_HANOI;
  cTerrainBlock.data[0*3+2]= 1;
  cTerrainBlock.data[1*3+0]= cTERRAIN_BLOCK;
  cTerrainBlock.data[1*3+1]= cTERRAIN_BLOCK;
  cTerrainBlock.data[1*3+2]= 1;
  cTerrainBlock.data[2*3+0]=-cTERRAIN_BLOCK;
  cTerrainBlock.data[2*3+1]= cTERRAIN_BLOCK;
  cTerrainBlock.data[2*3+2]= 1;
  cTerrainBlock.data[3*3+0]=-cTERRAIN_BLOCK;
  cTerrainBlock.data[3*3+1]= jLASER_OFFSET+cTERRAIN_HANOI;
  cTerrainBlock.data[3*3+2]= 1;  
  cnt=0;
  for (c1=-2;c1<=2;c1++)                // turning
  for (c2=-2;c2<=2;c2++)                // max slide sidewards
  for (c3=-2;c3<=2;c3++) {              // max front & back
    cnt+=3;
    cParam[cnt++]=-sqrt((float)(c1*c1+c2*c2+c3*c3))*0.01; // sqrt(12)*0.01=0.03464102
  }
  cMovesAura.data[ 0]=+1.0f*jHUMAN_RADIUS; cMovesAura.data[ 1]= 0.0f; cMovesAura.data[ 2]=1;
  cMovesAura.data[ 3]=+1.3f*jHUMAN_RADIUS; cMovesAura.data[ 4]= 0.7f; cMovesAura.data[ 5]=1;
  cMovesAura.data[ 6]=-1.3f*jHUMAN_RADIUS; cMovesAura.data[ 7]= 0.7f; cMovesAura.data[ 8]=1;
  cMovesAura.data[ 9]=-1.0f*jHUMAN_RADIUS; cMovesAura.data[10]= 0.0f; cMovesAura.data[11]=1;
}

void cProcess(SDL_Event &mySDL_Event) {
  jDEBUG("cProcess");
  int c1;
  if (mySDL_Event.type==SDL_KEYDOWN) {
    switch (mySDL_Event.key.keysym.sym) {
      case SDLK_e:      jTog[jTOG_PROFILE_EQUALIZED]=!jTog[jTOG_PROFILE_EQUALIZED];   break;
      case SDLK_m:      cDisplay++; cDisplay%=cDISPLAY;                               break;
      case SDLK_n:      jMover->active=!jMover->active;                               break;
      case SDLK_w:      mMover->active=!mMover->active;                               break;
      case SDLK_SPACE:  jTog[jTOG_SPACE_DOWN]=true;                                   break;
      case SDLK_y:      mRouting(); mMarking();                                       break;
    }
  }
  if (mySDL_Event.type==SDL_KEYUP) {
    switch (mySDL_Event.key.keysym.sym) {
      case SDLK_SPACE:  jTog[jTOG_SPACE_DOWN]=false;                                  break;
    }
  }  
  if (mySDL_Event.type==SDL_MOUSEBUTTONDOWN) {
    bool pln=false;
    int pix=mySDL_Event.button.x;
    int piy=mySDL_Event.button.y;
    if (mySDL_Event.button.button==SDL_BUTTON_LEFT&&cDisplay!=cDISPLAY_ATLAS) {
      matrix<float> tmp(3,1);
      if (jHUD_MAP_X<pix&&pix<jHUD_MAP_X+jMAP_W&&jHUD_MAP_Y<piy&&piy<jHUD_MAP_Y+jMAP_H) {
        tmp.data[0]=(piy-jHUD_MAP_Y-jMAP_Y)*jMAP2GND;
        tmp.data[1]=(pix-jHUD_MAP_X-jMAP_X)*jMAP2GND;
        tmp.data[2]=1;
        cTarget=tmp;
      }
    }
  }
  if (mySDL_Event.type==SDL_MOUSEBUTTONUP) {
  }
}

void cControl(void) {  
  if (jTic[jTOC_LAST_SENSORS]<jMover->stamp+jROLLOUT)
    cStopped=cPos.aff_pnt(2);
}

void cHUD(void) {
  int c1,c2,c3;
  int pix,piy,pin;
  Uint32 col;
  Uint8 alp=0xff;
  int rad;
  double tmp;
  double flx=modf(pPos.data[7],&tmp);
  double fly=modf(pPos.data[6],&tmp);
  SDL_Rect mySDL_Rect;
  sprintf(jChar,"l%3d r%3d R%d",jTic[jTOC_TIME_LOCALIZE],jTic[jTOC_TIME_ROUTING],jTic[jTOC_TIME_ROUTING2]);
  jDrawString(screen,jFont,jChar,jCOL2,11);
  if (cDisplay!=cDISPLAY_ATLAS) {
    matrix<float> pos(3,1);
    matrix<float> ofs(3,1);    
    matrix<float> pnt;
    // BEGIN: markup
    col=SDL_MapRGBA(&jSDL_PixelFormat,jGRAY,jGRAY,jGRAY, 64); // grey
    for (c1=-6;c1<=6;c1++) {
      mySDL_Rect.x=(int)(jMAP_X+(c1-flx)*jGND2MAP_INT);
      mySDL_Rect.y=0;
      mySDL_Rect.w=1;
      mySDL_Rect.h=jMAP_H;
      SDL_FillRect(cMap,&mySDL_Rect,col);
      mySDL_Rect.x=0;
      mySDL_Rect.y=(int)(jMAP_Y+(c1-fly)*jGND2MAP_INT);
      mySDL_Rect.w=jMAP_W;
      mySDL_Rect.h=1;
      SDL_FillRect(cMap,&mySDL_Rect,col);
    }
    // END: markup
    // BEGIN: draw planning related    
    jDraw(jIN_MAP,cTarget.data   ,2,SDL_MapRGBA(&jSDL_PixelFormat,255,255, 64,alp),&filledEllipseRGBA);
    jDraw(jIN_MAP,cTargetOld.data,2,SDL_MapRGBA(&jSDL_PixelFormat,196,196, 64,alp),&ellipseRGBA);
    // BEGIN: draw stones and detected movements
    for (c1=0;c1<cStone.numel;c1+=3)
      jDraw(jIN_MAP,&cStone.data[c1],1,0xffffff00,filledEllipseRGBA);
    pix=piy=0;
    for (c1=0;c1<cMoves.numel;c1+=3)                    // little red and blue dots that indicate motion
      if (1.01f<cMoves.data[c1+2]) {
        ++pix;
        jDraw(jIN_MAP,&cMoves.data[c1],1,0xffff0000,filledEllipseRGBA);
      } else {
        ++piy;
        jDraw(jIN_MAP,&cMoves.data[c1],1,0xff0000ff,filledEllipseRGBA);
      }
    if (pix+piy) {
      sprintf(jChar,"detected movements in %i out %i",pix,piy);
      jBulletin.append(new std::string(jChar));
    }
    // END: draw detected movements
    mySDL_Rect.x=jHUD_MAP_X;
	  mySDL_Rect.y=jHUD_MAP_Y;
	  switch (cDisplay) {
    	case cDISPLAY_GEOGRAPHY: {
    	  SDL_BlitSurface(cTerrainDraw,NULL,screen,&mySDL_Rect);
      	SDL_BlitSurface(cProfileDraw,NULL,screen,&mySDL_Rect);
      	break;
    	}
    	case cDISPLAY_ROUTING: {   	        	  
    	  SDL_BlitSurface(cTerrainDraw,NULL,screen,&mySDL_Rect);
    	  if (!jTog[jTOG_SPACE_DOWN])
    	    SDL_BlitSurface(cDensityDraw,NULL,screen,&mySDL_Rect);
    	  else
    	    SDL_BlitSurface(mDensityDraw,NULL,screen,&mySDL_Rect);
    	  // BEGIN: draw laser segments
        /*
        c2 =cLaserSpot.size[2];
        c3 =cLaserSpot.size[2]+cLaserSpot.size[0];
        c3%=cLaserSpot.numel;
        int segr=0;
        int seGr=0;
        for (c1=0;c1<cLaserSpot.size[0];c1++) {
          if (cLaserSpot.data[c2+c1]) 
            segr++;
          else
            if (segr) {
              pin=cLaserSpot.data[c2+c1-1];
              sprintf(jChar,"%i",segr);
              jDrawString(cMap,jFonr,jChar,pin%jMAP_W,pin/jMAP_W);
              segr=0;
            }
          if (cLaserSpot.data[c3+c1]) 
            seGr++;
          else
            if (seGr) {
              pin=cLaserSpot.data[c3+c1-1];
              sprintf(jChar,"%i",seGr);
              jDrawString(cMap,jFont,jChar,pin%jMAP_W,pin/jMAP_W);
              seGr=0;
            }
        }
        */
        // END: draw laser segments
    	  break;
	    }
    }
  }
  // BEGIN: update jMonitos
  float res;
  matrix<int> app;
  jDrawString(jMonitos,jFont,"d",100,0);
  c1=14;
  while (cOptimize.token(app)) {
    sprintf(jChar,"%i",app.data[0]);
    jDrawString(jMonitos,jFont,jChar,100+c1,0);
    c1+=7;
  }
  matrix<float> pos=pPos*cPos;
  sprintf(jChar,"p%6.2f\t %6.2f",pos.data[6],pos.data[7]);
  jDrawString(jMonitos,jFont,jChar,151,178);
  // END: update jMonitos
}


// this function outputs into folder SAV
void cShutdown(void) {
  jMarker.store("sav\\marker.mat");                  // marker
  matrix<unsigned int> pal(jPALETTE_W,jPALETTE_H);  // palette
  SDL_LockSurface(jPaletteDraw);
  pal.data=(Uint32*)(jPaletteDraw->pixels);
  pal.store("sav\\palette.mat");
  SDL_UnlockSurface(jPaletteDraw);
  pPos.store("sav\\ppos.mat");
  cPos.store("sav\\cpos.mat");
}
