// code by jph

// clear list of jMoviton's: humans, stones, marks of path
void cReset(linked<jMoviton*>& plc) {
  jMoviton* tok;
  while (plc.token(tok)) 
    if (tok->id<=jMOVITON_ID_HUMAN) {           // clear linked list, and store into array
      plc.remove();                             // does not delete the content
      delete tok;                               // this deletes the content
    }
  if (&plc==&pMoves)                            // when list pMoves is cleared, then pMover should be removed 100%
    pMover=jMover;
}

// clear list of jMoviton's: humans, stones, marks of path
int cCount(linked<jMoviton*>& plc) {
  int cnt=0;
  jMoviton* tok;
  while (plc.token(tok))
    cnt++;
  return cnt;
}


// resets all the map
void cReset(bool load) {
  jDEBUG("cReset load");
  int c1;
  for (c1=0;c1<cTERRAIN;c1++)
    cTerrain[c1]=cTERRAIN_NOGO;                 // blit
  for (c1=0;c1<cLaserSpot.numel;c1++)           
    cLaserSpot.data[c1]=0;                      // blit
  SDL_FillRect(cTerrainDiff,NULL,0);            // blit  
  SDL_FillRect(cTerrainHoly,NULL,0);            // blit  
  SDL_FillRect(cDensityDraw,NULL,0);            
  SDL_FillRect(cProfileDraw,NULL,0);            // blit  
  cPos=matrix<float>(3,3,"eye");                // blit
  if (load) {
    jTog[jTOG_ATLAS_CALIBRATED]=true;
    matrix<float> tmp;
    tmp=matrix<float>("sav\\cpos.mat");
    if (tmp.data)
      cPos=tmp;
    tmp=matrix<float>("sav\\ppos.mat");
    if (tmp.data) {
      pPos.data[6]=tmp.data[6];                 // put robot at typical starting position
      pPos.data[7]=tmp.data[7];
    }
    pInv.data[6]=-pPos.data[6];
    pInv.data[7]=-pPos.data[7];
  }
  cInv=cPos.solve(matrix<float>(3,3,"eye"));    // blit
  jMover->stamp=jTic[jTOC_LAST_SENSORS];        // pretend j2b2 has actively moved
  jMover->pos=pPos*cPos;
  jMover->track.clear();
  jMover->track.prepend(jMover->pos);
  jMover->rested=jMover->pos;
  cStopped=cPos.aff_pnt(2);
  cTarget=cPos.aff_pnt(2);
  cReset(pMoves);                               // sets pMover=jMover
  cReset(pStone);
  int fut=jCLOCK_FUNC+3000;
  jTic[jTOC_NEXT_PROFILE]=fut;                  // delay camera mapping
  jTic[jTOC_NEXT_EXTRAPOLATION]=fut;            // delay enhanced localization method
}

// performs blit of a single surface quite efficiently
SDL_Surface* cBlits(SDL_Rect* mySDL_Rect,SDL_Surface* srf) {
  jDEBUG("cBlits");
  SDL_FillRect(cTerrainStub,NULL,0);
  SDL_SetAlpha(srf,0,0);
  SDL_SetAlpha(cTerrainStub,0,0);
  SDL_BlitSurface(srf,mySDL_Rect,cTerrainStub,NULL);  
  SDL_SetAlpha(srf,SDL_SRCALPHA,SDL_ALPHA_TRANSPARENT);   // SDL_ALPHA_OPAQUE works as well !?
  SDL_SetAlpha(cTerrainStub,SDL_SRCALPHA,SDL_ALPHA_TRANSPARENT);
  SDL_Surface* ret=cTerrainStub;                // preserve stub
  cTerrainStub=srf;                             // copy information into stub
  return ret;
}

// makes robot center of map if necessary
void cBlits(void) {
  jDEBUG("cBlits")
  int c1,c2,cl;
  matrix<float> ofs=cPos.aff_vec(2); // map position becomes the offset vector
  if (ofs.norm(2)<cBLIT_RADIUS||jTog[jTOG_HEAVY_DUTY]) {
    jDrawString(screen,jFond,"B",cICON_BLIT_X,cICON_Y); 
    return;   
  }
  jDrawString(screen,jFont,"B",cICON_BLIT_X,cICON_Y);
  int pix,piy,pin;
  SDL_Rect mySDL_Rect;
  // BEGIN: extract relevant terrain
  int ter[cTERRAIN];
  for (c1=0;c1<cTERRAIN;c1++) {
    ter[c1]=cTerrain[c1];
    cTerrain[c1]=cTERRAIN_NOGO;
  }
  jLocal2map(ofs,pix,piy);            // offset to pixels
  ofs.data[0]=(piy-jMAP_Y)*jMAP2GND;  // for consistency use distances of pixels (rounded)
  ofs.data[1]=(pix-jMAP_X)*jMAP2GND;  
  mySDL_Rect.x=pix-jMAP_X;
  mySDL_Rect.y=piy-jMAP_Y;
  mySDL_Rect.w=jMAP_W;
  mySDL_Rect.h=jMAP_H;
  SDL_FillRect(cTerrainStub,NULL,0); // serves as mask to transfer only valid information
  SDL_FillRect(cTerrainStub,&mySDL_Rect,0xffffffff);
  SDL_LockSurface(cTerrainStub);
  Uint32* myStub=(Uint32*)(cTerrainStub->pixels);
  int gow=jMAP_W-2,goh=jMAP_H-2;
  int dil=jMAP_X-pix+jMAP_W*(jMAP_Y-piy);
  for (c1=2;c1<goh;c1++) {
    cl=c1*jMAP_W;
    for (c2=2;c2<gow;c2++) {
      pin=cl+c2-dil;
      if (0<pin&&pin<cTERRAIN)
        cTerrain[cl+c2]=ter[pin]&myStub[pin];
    }
  }
  SDL_UnlockSurface(cTerrainStub);
  // END: extract relevant terrain
  // BEGIN: shift laser points for motion detection (delicate!)
  for (c1=0;c1<cLaserSpot.numel;c1++) {
    if (cLaserSpot.data[c1]) {
      pin=cLaserSpot.data[c1]+dil;
      if (0<pin&&pin<cTERRAIN)
        cLaserSpot.data[c1]=pin;
      else
        cLaserSpot.data[c1]=0;
    }
  }
  // END: shift laser points for motion detection
  // BEGIN: blit each surface with information
  mySDL_Rect.x=pix-jMAP_X; mySDL_Rect.y=piy-jMAP_Y; mySDL_Rect.w=jMAP_W; mySDL_Rect.h=jMAP_H;  
  cTerrainDiff=cBlits(&mySDL_Rect,cTerrainDiff);
  mySDL_Rect.x=pix-jMAP_X; mySDL_Rect.y=piy-jMAP_Y; mySDL_Rect.w=jMAP_W; mySDL_Rect.h=jMAP_H;
  cProfileDraw=cBlits(&mySDL_Rect,cProfileDraw);
  // END: blit each surface with information
  cPos.data[6]-=ofs.data[0];
  cPos.data[7]-=ofs.data[1];
  pPos.data[6]+=ofs.data[0];
  pPos.data[7]+=ofs.data[1];
  pInv.data[6]=-pPos.data[6];
  pInv.data[7]=-pPos.data[7];  
  cInv=cPos.solve(matrix<float>(3,3,"eye"));
  cStopped-=ofs;
  cTarget-=ofs;
  jTog[jTOG_ATLAS_CALIBRATED]=true;               // this triggers cAtlaz()
  jTog[jTOG_HEAVY_DUTY]=true;
}

// multi-res optimization for localization
// returns (number of iterations)-1
int cLocalize(int cod,float res) {
  int c1,c2,c3;
  int pix,piy,pin;
  int cnt=0,sum,ret=0;
  float ang=res*2.00f*jDEG2RAD;                   // this is 2 degrees
  float bst=res*0.03f;                            // this is 3 centimeters
  float cmp;
  for (c1=-2;c1<=2;c1++)                          // turning
  for (c2=-2;c2<=2;c2++)                          // max slide sidewards
  for (c3=-2;c3<=2;c3++) {                        // max front & back
    cParam[cnt++]=c1*ang;
    cParam[cnt++]=c2*bst;
    cParam[cnt++]=c3*bst;
    cnt++;
  }
  matrix<float> ofs(3,3,"eye");
  matrix<float> frm;
  matrix<float> pnt;  
  cnt=0;
  int ind=0;
  matrix<int> app(5,1);
  app.data[0]=cod;
  while (ind!=248) {
    matrix<float> mtc=cPos;                       // initially best match is cPos, now look for better one
    bst=-100.0f;                                  // threshhold for comparison
    for (c1=0;c1<cPARAM;c1+=4) {
      ofs.data[0]= cos(cParam[c1]);
      ofs.data[1]= sin(cParam[c1]);
      ofs.data[3]=-ofs.data[1];
      ofs.data[4]= ofs.data[0];
      ofs.data[6]= cParam[c1+1];
      ofs.data[7]= cParam[c1+2];
      frm=cPos*ofs;
      pnt=frm*jLaserLocal;
      sum=0;
      for (c2=0;c2<pnt.numel;c2+=3) {
        pix=(int)(jMAP_X+pnt.data[c2+1]*jGND2MAP);
        piy=(int)(jMAP_Y+pnt.data[c2  ]*jGND2MAP);
        pin=piy*jMAP_W+pix;
        if (0<pin&&pin<cTERRAIN)
          sum+=cTerrain[pin];
      }
      cmp=sum*0.010989f+cParam[c1+3];             // computes average plus penalty
      if (bst<cmp) {
        bst=cmp;
        mtc=frm;
        ind=c1;
      }
    }
    cPos=mtc;
    ret+=ind!=248;
    app.data[1]=ind;      cod =ind/4;
    app.data[2]=cod%5-2;  cod/=5;
    app.data[3]=cod%5-2;  cod/=5;
    app.data[4]=cod-2;
    cOptimize.append(app);
  }
  return ret;
}

// corrects numerically the aff trf matrix pos and returns inverse
// necessary for long term stability
matrix<float> cJustify_private(matrix<float>& pos) {
  jDEBUG("cJustify")
  float ang,def,cod,sid;
  matrix<float> nrm0=pos.aff_vec(0); nrm0.normalize(2);
  matrix<float> nrm1=pos.aff_vec(1); nrm1.normalize(2);
  ang=acos(nrm0|nrm1);
  def=(ang-jM_PI2)*0.5f;
  cod=cos(def);
  sid=sin(def);
  pos.data[0]= cod*nrm0.data[0]-sid*nrm0.data[1];
  pos.data[1]=+sid*nrm0.data[0]+cod*nrm0.data[1];
  pos.data[3]= cod*nrm1.data[0]+sid*nrm1.data[1];
  pos.data[4]=-sid*nrm1.data[0]+cod*nrm1.data[1];
  pos.data[8]=1;
  return pos.solve(matrix<float>(3,3,"eye"));
}

// elapsed time communicated between function of localization
float jDt_protected=0;

// updates position of robot if not stopped
void cLocalize(void) {
  jDEBUG("cLocalize")
  int c1,cnt;
  matrix<int> app;
  matrix<float> tmp(3,1);
  matrix<float> mot;  
  int clk=jCLOCK_FUNC;
  // BEGIN: find current orientation and position 
  jTic[jTOC_TIME_LOCALIZE]=clk;
  float res,alp;
  matrix<float> gue(3,3);
  if (jTic[jTOC_NEXT_EXTRAPOLATION]<jTic[jTOC_LAST_SENSORS]) {
    alp=jVel.data[0]*jDt_protected;    
    gue.data[0]= cos(alp); gue.data[3]=-sin(alp); gue.data[6]=jVel.data[1]*jDt_protected;
    gue.data[1]= sin(alp); gue.data[4]= cos(alp); gue.data[7]=jVel.data[2]*jDt_protected;
                                                  gue.data[8]=1;
    cPos=cPos*gue;                                // cInv still has the old reference :-)
  }
  while (cOptimize.token(app))
    cOptimize.remove();
  res=1.0f;
  for (c1=0;c1<4;c1++) {
    cLocalize(c1,res);
    res*=0.6;
  }
  clk=jCLOCK_FUNC;
  jTic[jTOC_TIME_LOCALIZE]=clk-jTic[jTOC_TIME_LOCALIZE];
  // END: find current orientation and position 
  // BEGIN: raw velocity computation
  mot=cInv*cPos;                                  // genius, because cInv is old and cPos is new
  tmp.data[0]=asin(mot.data[1]);
  tmp.data[1]=     mot.data[6] ;
  tmp.data[2]=     mot.data[7] ;
  // END: raw velocity computation
  // BEGIN: velocity estimation
  float dt=(clk-jTic[jTOC_LAST_SLAM])*0.001f;     // msec to sec
  dt=MIN(MAX(0.102f,dt),0.6f);                    // truncates the framerate to a reasonable value
  jDt_protected=dt;
  float dti=1.0f/dt;
  sprintf(jChar,"f %5.2f",dti);
  jDrawString(screen,jFont,jChar,0,11);
  jTic[jTOC_LAST_SLAM]=clk;
  jVelMedian.prepend(tmp*dti);
  cnt=jSPEED_MEDIAN;
  matrix<float> tok(3,1);
  array<float> srt(1,&cnt,0.0f);
  for (c1=0;c1<3;c1++) {
    cnt=0;
    while (jVelMedian.token(tok)) {
      if (cnt<jSPEED_MEDIAN)
        srt.data[cnt++]=tok.data[c1];
      else
        jVelMedian.remove();
    }
    srt.sort();
    jVel.data[c1]=srt.data[1];                    // jVel becomes the median of 3 consecutive raw measurements
  }
  // END: velocity computation
  cInv=cJustify_private(cPos);                    // performs numerical correction
  jMover->pos=pPos*cPos;                          // update even the last manifestation of j2b2
}

// updates map at positions where necessary
// avoids scattered laser points
void cMapping(void) {
  jDEBUG("cMapping")
  int c1,c2;  
  SDL_FillRect(cTerrainStub,NULL,0);
  SDL_FillRect(cTerrainTria,NULL,0);
  matrix<float> ofs(3,1);                         // robot ground profile
  ofs.data[0]=0; ofs.data[1]=jAXIS_OFFSET; ofs.data[2]=1;
  jDraw(jIN_TERRAINTRIA,cPos*cTerrainBlock,0xff00ffff,&filledPolygonRGBA);
  jDraw(jIN_TERRAINSTUB,cPos*jExplode(540,cTERRAIN_RANGEMAX,cTERRAIN_OFFSET),0xff000000|cTERRAIN_FREE|cTERRAIN_STUB,&filledPolygonRGBA);
  // BEGIN: prepare part of map determined by perceived data
  jDEBUG("perceived")
  matrix<float> seq;
  SDL_Rect mySDL_Rect;  
  cLaserList.clear();
  while (jLaserList.token(seq)) {
    matrix<float> sek(3,seq.size[1]);
    for (c1=0;c1<seq.size[1];c1++) {
      sek.data[c1*3+0]=seq.data[c1*2+0];
      sek.data[c1*3+1]=seq.data[c1*2+1]+jLASER_OFFSET;
      sek.data[c1*3+2]=1;
    }
    sek=cPos*sek;
    cLaserList.append(sek);    
    matrix<int> sei(2,seq.size[1]);
    for (c1=0;c1<sek.size[1];c1++) {
      sei.data[c1*2+0]=(int)(jMAP_X+sek.data[c1*3+1]*jGND2MAP);
      sei.data[c1*2+1]=(int)(jMAP_Y+sek.data[c1*3+0]*jGND2MAP);
    }
    for (c1=2;c1<sek.size[1]-2;c1++)
      filledEllipseRGBA(cTerrainStub,sei.data[c1*2+0],sei.data[c1*2+1],2,2,000,000,cTERRAIN_NOGO,0xff);      
    for (c1=1;c1<sek.size[1]-1;c1++) {
      mySDL_Rect.x=sei.data[c1*2+0]-1;
      mySDL_Rect.y=sei.data[c1*2+1]-1;
      mySDL_Rect.w=3;
      mySDL_Rect.h=3;
      SDL_FillRect(cTerrainStub,&mySDL_Rect,0xff000000|cTERRAIN_AURA);
    }
    for (c1=0;c1<sek.size[1]-1;c1++)
      lineRGBA(cTerrainStub,
        sei.data[c1*2+0],sei.data[c1*2+1],sei.data[c1*2+2],sei.data[c1*2+3],000,000,cTERRAIN_OBST,0xff);
  }
  // END: prepare part of map determined by perceived data
  // BEGIN: free terrain around Marsokhod
  jMoviton* tok;
  while (pMoves.token(tok)) 
    if (jMOVITON_ID_HUMAN<tok->id) { // only the robots
      jDraw(jIN_TERRAINTRIA,pInv*tok->rested**tok->contour,0xff00ffff,&filledPolygonRGBA);
      jDraw(jIN_TERRAINSTUB,pInv*tok->rested**tok->contour,
          0xff000000+(jMOVITON_ID_HUMAN<tok->id)*tok->active*(cTERRAIN_FREE|cTERRAIN_STUB)+(1-tok->active)*cTERRAIN_EOOB,&filledPolygonRGBA);
    }
  // END: free terrain around Marsokhod  
  // BEGIN: merge perceived part of map into permanent map
  int den;
  SDL_FillRect(cTerrainDraw,NULL,0);                  // attention!
  SDL_LockSurface(cTerrainDraw);
  SDL_LockSurface(cTerrainDiff);
  SDL_LockSurface(cTerrainTria);  
  SDL_LockSurface(cTerrainStub);  
  Uint32* myStub=(Uint32*)(cTerrainStub->pixels);     // to manipulate pixel array
  Uint32* myTria=(Uint32*)(cTerrainTria->pixels);     // to manipulate pixel array
  Uint32* myDraw=(Uint32*)(cTerrainDraw->pixels);  
  Uint32* myDiff=(Uint32*)(cTerrainDiff->pixels);     // to manipulate pixel array    
  for (c1=0;c1<cTERRAIN;c1++) {
    myDiff[c1]>>=1;
    if (myTria[c1]&&myStub[c1]&0xff000000) {          // current profile exists at this point
      myDiff[c1] |=(myStub[c1]&cTERRAIN_STUB)>>2;     // 0010 0000 => 0000 1000
      den=myStub[c1]&cTERRAIN_WALL;
      if (den==cTERRAIN_AURA)
        cTerrain[c1]=MAX(cTerrain[c1],cTERRAIN_AURA);
      else
        cTerrain[c1]=den;  
    }
    if (cTERRAIN_NOGO<cTerrain[c1])
      if (cTERRAIN_FREE<cTerrain[c1])
        myDraw[c1]=0xff000000|cTerrain[c1]<<11;       // vive l'operator precedence                  
      else
        myDraw[c1]=0xffd0d0d0^(myDiff[c1]&1)<<6^(myDiff[c1]&cMOVES_MASK)<<11; // vive l'operator precedence          
  }
  SDL_UnlockSurface(cTerrainStub);
  SDL_UnlockSurface(cTerrainTria);  
  SDL_UnlockSurface(cTerrainDiff);                    // to manipulate pixel array    
  SDL_UnlockSurface(cTerrainDraw);
  // END: merge perceived part of map into permanent map
  // BEGIN: enter solids from atlas into cTerrain
  if (!jTog[jTOG_ATLAS_CALIBRATE])
    for (c1=0;c1<cAtlasNum;c1++)                      // walls in atlas have precedence
      cTerrain[cAtlasInd[c1]]|=cTERRAIN_WALL;
  // END: enter solids from atlas into cTerrain
}

// creates spheres around obstacles
// used also in motion planner for mhk
void cDensing(float mrg,float mps) {
  int c1,c2;
  int rad,rae;
  rad=(int)(mrg*jGND2MAP);                          // transfer terrain to density
  rae=(int)(mps*jGND2MAP);                          // 4 cm around robots      
  SDL_FillRect(cDensityDraw,NULL,0);
  for (c1=0;c1<cDENSITY;c1++)
    if (cTERRAIN_FREE<cTerrain[c2=cDensitySeed[c1]])
      if (cTERRAIN_EOOB<cTerrain[c2])
        filledEllipseRGBA(cDensityDraw,c2%jMAP_W,c2/jMAP_W,rad,rad,0xff,0xff,0xff,0xff);
      else
        filledEllipseRGBA(cDensityDraw,c2%jMAP_W,c2/jMAP_W,rae,rae,0xff,0xff,0xff,0xff);
  rad=(int)((mrg-jROBOT_RADIUS)*jGND2MAP);          // ensure that robot can leave spot even when close to a wall
  filledEllipseRGBA(cDensityDraw,                   // clear robot area
    (int)(jMAP_X+cPos.data[7]*jGND2MAP),
    (int)(jMAP_Y+cPos.data[6]*jGND2MAP),
    rad,rad,0x00,0x00,0x00,0xff);
  rad=(int)((mrg-mSIZE0+0.04f)*jGND2MAP);           // ensure that mhk can leave spot even when close to a wall
  filledEllipseRGBA(cDensityDraw,                   // clear robot area
    (int)(jMAP_X+mPos.data[7]*jGND2MAP),
    (int)(jMAP_Y+mPos.data[6]*jGND2MAP),
    rad,rad,0x00,0x00,0x00,0xff);
  Uint32* myDraw;
  if (-jPERMILLE<jGetSpeed.data[0]) {               // mmh. is this good!? when j2b2 drives forward
    SDL_LockSurface(cDensityDraw);
    myDraw=(Uint32*)(cDensityDraw->pixels);    
      for (c1=0;c1<cDrainNum;c1++)                  // red lines in atlas mean: no-trespassing
        myDraw[cDrainInd[c1]]=0xffff0000;
    SDL_UnlockSurface(cDensityDraw);
  }
  filledEllipseRGBA(cDensityDraw,                   // make ROBOT accessible (despite RED, or margin)
    (int)(jMAP_X+cPos.data[7]*jGND2MAP),
    (int)(jMAP_Y+cPos.data[6]*jGND2MAP),
    2,2,0x00,0x00,0x00,0xff);
  SDL_LockSurface(cDensityDraw);
  myDraw=(Uint32*)(cDensityDraw->pixels);
  for (c1=0;c1<cTERRAIN;c1++)
    cDensity[c1]=cTerrain[c1]==cTERRAIN_FREE&&!(myDraw[c1]&0xff0000);
  for (c1=0;c1<jMAP_W*2+2;c1++)
    cDensity[c1]=0;
  for (c1=cTERRAIN-jMAP_W*2-2;c1<cTERRAIN;c1++)
    cDensity[c1]=0;
  for (c1=0;c1<cTERRAIN;c1+=jMAP_W) {
    cDensity[c1]=0;
    cDensity[c1+1]=0;
  }
  for (c1=0;c1<cTERRAIN;c1++)
    if (cDensity[c1])
      myDraw[c1]=0xff800080;
    else
      myDraw[c1]=0;    
  SDL_UnlockSurface(cDensityDraw);        
}

// cRouting computes from robots position distances to all points in density
// is like floodfill with distances
void cRouting(int pia,int typ) {
  jDEBUG("cRouting pia typ")
  int c1,pii,cnt=0;
  float   met;
  int*    ofs=&jRouteOfs[typ<<3];                     // evil times pi
  float*  fac=&jRouteFac[typ<<3];  
  for (c1=0;c1<cTERRAIN;c1++)
    cRouteMask[c1]=0;  
  int* lizt0=(int*)cTerrainStub->pixels;              // janne suggests to use min heap instead of list
  int  lizt0_cnt=0;
  int  lizt0_tok=0;
  int* lizt1=&lizt0[cTERRAIN>>1];                     // safe evil
  int  lizt1_cnt=0;
  int  lizt1_tok=0;
  int* liztt;
  lizt0[lizt0_cnt++]=pia;
  cRouteDist[pia]=0;
  cRoutePred[pia]=pia;
  while (lizt0_tok<lizt0_cnt&&cnt<cROUTE_QUALITY) {
    cnt++;
    while (lizt0_tok<lizt0_cnt) {
      pia=lizt0[lizt0_tok++];
      for (c1=0;c1<8;c1++) {                          // visit eight neibors
        pii=pia+ofs[c1];
        if (cDensity[pii])                            // only visit explored terrain (metric =0 whereever unexplored)
          if (cRouteDist[pia]+fac[c1]<cRouteDist[pii]) {
            cRouteDist[pii]=cRouteDist[pia]+fac[c1];
            cRoutePred[pii]=pia;
            if (cRouteMask[pii]<cnt) {                // prevents to have the same vertex added in the same iteration step
              cRouteMask[pii]=cnt;
              lizt1[lizt1_cnt++]=pii;
            }
          }
      }
    }
    lizt0_tok=0;
    lizt0_cnt=lizt1_cnt;
    lizt1_cnt=0;
    liztt=lizt0;
    lizt0=lizt1;
    lizt1=liztt;
  }
}

// density map computation
// main routing
void cRouting(void) {
  jDEBUG("cRouting")
  int c1,c2;
  int pix,piy,pia;
  if (jTic[jTOC_NEXT_NAVIGATION]<jTic[jTOC_LAST_SENSORS]||cROUTEVALID<(cTarget-cTargetOld).norm(2)) {
    jTic[jTOC_NEXT_NAVIGATION]=jTic[jTOC_LAST_SENSORS]+1500;    // sometimes there is old geometry in map that is routed around but is free later
    jTog[jTOG_HEAVY_DUTY]=true;
    // BEGIN: clear all data from previous routing etc
    jTic[jTOC_TIME_ROUTING]=jCLOCK_FUNC;
    if (!jLocal2map(cTarget,pix,piy))
      cTarget=cPos.aff_pnt(2);    
    cTargetOld=cTarget;
    for (c1=0;c1<cTERRAIN;c1++) {
      cRouteDist[c1]=cTERRAIN;
      cRoutePred[c1]=0;
    }
    int rad,rae;
    cDensing(cDENSITY_OFFSET,cDENSITY_OFFSET+0.04f);
    // END: use drawing to create safety margins
    // BEGIN: fancy shortest path algorithm
    jLocal2map(cTarget,pix,piy);
    pia=piy*jMAP_W+pix;
    SDL_LockSurface(cTerrainStub);
    cRouting(pia,0);                                  // some crazy shit!
    cRouting(pia,1);                                  // some crazy shit!    
    SDL_UnlockSurface(cTerrainStub);
    // END: fancy shortest path algorithm
    // BEGIN: visualize distance profile produced by routing
    if (cDisplay==cDISPLAY_ROUTING) {
      SDL_LockSurface(cDensityDraw);
      Uint32* myDraw=(Uint32*)(cDensityDraw->pixels);
      for (c1=0;c1<cTERRAIN;c1++)
        if (cRouteDist[c1]<cTERRAIN) {
          myDraw[c1]=0xff007f00;
          c2=(int)cRouteDist[c1];
          c2&=0x1f;
          myDraw[c1]|=c2<<18;
        }
      SDL_UnlockSurface(cDensityDraw);
    }
    // END: visualize distance profile produced by routing
    jTic[jTOC_TIME_ROUTING]=jCLOCK_FUNC-jTic[jTOC_TIME_ROUTING];
    jDrawString(screen,jFont,"R",cICON_ROUTING_X,cICON_Y);
  } else
    jDrawString(screen,jFond,"R",cICON_ROUTING_X,cICON_Y);  
}

// checks if the map coordinate pnt is safe for j2b2 to be
bool cDensed(float* pnt) {
  int pix,piy,pin;
  pix=(int)(jMAP_X+pnt[1]*jGND2MAP);
  piy=(int)(jMAP_Y+pnt[0]*jGND2MAP);
  pin=piy*jMAP_W+pix;
  if (0<pix&&pix<jMAP_W&&0<piy&&piy<jMAP_H) 
    return cDensity[pin];
  else
    return false;
}

// checks if the line between map coordinates ori and dst is safe for j2b2 to "drive"
bool cDensed(matrix<float> ori,matrix<float> dst) {
  int c1;
  float num;
  bool flg=cDensed(ori.data)&&cDensed(dst.data);
  dst-=ori;
  num=dst.norm(2)*jGND2MAP;
  if (2<num) 
    for (c1=1;c1<num&&flg;c1++) 
      flg&=cDensed((ori+dst*(c1/num)).data);  
  return flg;
}

// function cPlanning starts from goal: cTarget and hops from predecessor to next predecessor 
// these pixel addresses are stored in a linked list (because the length of the path in pixels is
void cPlanning(jMoviton* tok) {
  jDEBUG("cPlanning")
  int c1;
  int pix,piy,pta;
  float lam,num;
  tok->plan.planned=false;
  tok->plan.safe=0.0f;                                      // measure of safe driving
  tok->plan.compass=tok->plan.compass=tok->pos.aff_vec(1);  //cCompass.data[2]=0;
  tok->plan.list.clear();                                   // since integers, "delete" not necessary
  tok->plan.count=0;                                        // this register is only for drawing purposes    
  if (jAtlas2map(tok->pos.aff_pnt(2),pix,piy)) {            // check if robots in the map
    matrix<float> pos=(pInv*tok->pos).aff_vec(2);
    pta=piy*jMAP_W+pix;                                     // pixel address of target      
    tok->plan.dist=cRouteDist[pta]*jMAP2GND;                // costs of the path are known from the beginning!  
    if (tok->plan.planned=cRoutePred[pta]) {                // hell, not again!          
      bool krt=true;
      while (cRoutePred[pta]&&pta!=cRoutePred[pta]) {       // hop from predecessor to next predecessor      
        tok->plan.list.append(pta);                         // until predecessor is NULL    
        if (krt) {                                          // extend compass
          tok->plan.count++;
          tok->plan.compass.data[0]=((pta/jMAP_W)-jMAP_Y)*jMAP2GND-pos.data[0];
          tok->plan.compass.data[1]=((pta%jMAP_W)-jMAP_X)*jMAP2GND-pos.data[1];
          tok->plan.safe=tok->plan.compass.norm(2);
          num=tok->plan.safe*jGND2MAP;
          for (c1=0;c1<(int)num;c1++)                       // like raytracing
            if (krt&=jLocal2map(pos+tok->plan.compass*(c1/num),pix,piy)) // when num == 0, we are not in this loop
              krt&=cDensity[piy*jMAP_W+pix];
        }
        pta=cRoutePred[pta];
      }
      tok->plan.compass.normalize(2);
    }
  }
}

// maps camera image to ground
void cProfile(void) {
  int c1,c2,cnt;
  int pix,piy,pin;
  Uint32 col;  
  SDL_LockSurface(cProfileDraw);
  Uint32* myDraw=(Uint32*)(cProfileDraw->pixels);  
  // BEGIN: fading of old camera images (image is gone after 60 sec)
  if (jTic[jTOC_NEXT_FADING]<jTic[jTOC_LAST_SENSORS]) {
    jTic[jTOC_NEXT_FADING]=jTic[jTOC_LAST_SENSORS]+1500;
    for (c1=0;c1<cTERRAIN;c1++) {
      col=myDraw[c1]>>24;
      if (4<col)
        myDraw[c1]=(col-1)<<24|myDraw[c1]&0xffffff; // TODO: check operator preced.
      else
        myDraw[c1]=0;
    }
  }
  // END: fading of old camera images  
  // BEGIN: analyse radial ground picturing
  c1=180;
  cnt=0;
  int ref=0;
  float len;
  float del=(cPROFILE_RANGEMAX-cPROFILE_RANGEMIN)/(float)cPROFILE_RANGERES;
  matrix<float> ray(3,1);
  matrix<int> evl(3,c1);  
  for (c1=-80;c1<=80;c1+=5) {
    evl.data[cnt+0]=c1;
    ray.data[0]=sin(c1*jDEG2RAD);
    ray.data[1]=cos(c1*jDEG2RAD);
    ray=cPos*ray;
    len=cPROFILE_RANGEMIN;                                    // 30 cm offset
    while (len<cPROFILE_RANGEMAX) {
      len+=del;
      pix=(int)(jMAP_X+(cPos.data[7]+ray.data[1]*len)*jGND2MAP);
      piy=(int)(jMAP_Y+(cPos.data[6]+ray.data[0]*len)*jGND2MAP);
      pin=piy*jMAP_W+pix;
      if (0<pin&&pin<cTERRAIN) {
        if (cTerrain[pin]!=cTERRAIN_FREE)
          break;
        col=myDraw[pin]&0xff000000;
        col>>=24;      
        evl.data[cnt+1]+=cPROFILE_ALPHA-col;
      } else
        break;
    }
    evl.data[cnt+1]/=cPROFILE_RANGERES;
    cnt+=3;
  }
  for (c1=6;c1<cnt-6;c1+=3) {
    for (c2=-6;c2<=6;c2+=3)
      evl.data[c1+2]+=evl.data[c1+c2+1];
    evl.data[c1+2]/=5;
    if (evl.data[ref+2]<evl.data[c1+2])
      ref=c1;
  }
  // END: analyse radial ground picturing
  // BEGIN: maps camera image to ground
  if (camera&&
      jTic[jTOC_NEXT_PTU]<jTic[jTOC_LAST_SENSORS]&&
      jPTUTIL_PROFILE_MIN<jOldPTU.data[1]&&      
      jTic[jTOC_NEXT_PROFILE]<jTic[jTOC_LAST_SENSORS]&&      
      !jTog[jTOG_HEAVY_DUTY]      
     ) {
    col=cPROFILE_ALPHA<<24|0xffffff;
    SDL_FillRect(cTerrainStub,NULL,0);
    jDraw(jIN_TERRAINSTUB,cPos*jSight[jCAMERA_MONO],0xffffff00,&filledPolygonRGBA);
    matrix<float> wld(3,1);
    wld.data[2]=1;
    SDL_Surface* prf;
    if (jTog[jTOG_PROFILE_EQUALIZED])
      prf=jGoggle;
    else
      prf=camera;
    SDL_LockSurface(cTerrainStub);
    SDL_LockSurface(prf);
    Uint32* myMask=(Uint32*)(cTerrainStub->pixels);
    Uint32* myCamP=(Uint32*)(prf->pixels);
    for (c1=0;c1<cTERRAIN;c1++)
      if (myMask[c1]&&cTerrain[c1]==cTERRAIN_FREE) {
        wld.data[0]=((c1/jMAP_W)-jMAP_Y)*jMAP2GND;
        wld.data[1]=((c1%jMAP_W)-jMAP_X)*jMAP2GND;       
        pin=jGnd2cam(jCAMERA_MONO,cInv*wld);
        if (0<pin)
          myDraw[c1]=myCamP[pin]&col;
      }
    SDL_UnlockSurface(prf);
    SDL_UnlockSurface(cTerrainStub);
    jTic[jTOC_NEXT_PROFILE]=jTic[jTOC_LAST_SENSORS]+5250;
    jTog[jTOG_HEAVY_DUTY]=true;
    jDrawString(screen,jFont,"P",cICON_PROFILE_X,cICON_Y);
  } else
    jDrawString(screen,jFond,"P",cICON_PROFILE_X,cICON_Y);
  // END: maps camera image to ground
  SDL_UnlockSurface(cProfileDraw);
  // BEGIN: camera control
  if (camera&&
      cPROFILE_ALPHA/3<evl.data[ref+2]&&
      jPTUTIL_PROFILE_MIN<jOldPTU.data[1]&&
      !jTog[jTOG_JOYSTICK]&&
      !jTog[jTOG_MARKER_CALIBRATION]
     )
    jSetPTU.data[0]=evl.data[ref+0]*jDEG2RAD;    
  // END: camera control
}

void cMovements(int ofs,unsigned int msk,Uint32 col,float wgt) {
  jDEBUG("cMovements protected")
  Uint32* myDiff=(Uint32*)(cTerrainDiff->pixels);
  int ind=0;
  int pix,piy,pin;
  matrix<float> pos(3,1);
  while (cLaserSpot.data[ofs+ind]) {                  // this is fucking insane (cLaserSpot contains pixel addresses)
    if (cMOVES_SIZE1*3==cMoves.numel)
      break;  
    pos.data[0]=pos.data[1]=pos.data[2]=0;
    while (cLaserSpot.data[ofs+ind]) {                // this is fucking insane (...and terminates with zero)
      if (myDiff[cLaserSpot.data[ofs+ind]]&msk) {     // accumulate those points
        pos.data[0]+=(cLaserSpot.data[ofs+ind]/jMAP_W-jMAP_Y)*jMAP2GND;
        pos.data[1]+=(cLaserSpot.data[ofs+ind]%jMAP_W-jMAP_Y)*jMAP2GND;
        pos.data[2]+=1.0f;
      }
      ind++;
    }
    if (jPERMILLE<pos.data[2]) {                      // more than 0 points added?
      pos.data[0]/=pos.data[2];
      pos.data[1]/=pos.data[2];
      pix=(int)(jMAP_X+pos.data[1]*jGND2MAP);
      piy=(int)(jMAP_Y+pos.data[0]*jGND2MAP);
      pin=piy*jMAP_W+pix;
      if (0<pin&&pin<cTERRAIN) {                      // add motion point only over free terrain by atlas
        cMoves.data[cMoves.numel+0]=pos.data[0];
        cMoves.data[cMoves.numel+1]=pos.data[1];
        cMoves.data[cMoves.numel+2]=wgt;
        cMoves.numel+=3;
      }
    }
    ind++;
  }
}

void cMovements(void) {
  jDEBUG("cMovements")
  int c1,c2;
  int pix,piy,pin;
  // BEGIN: a legend is born
  int buf[cMOVES_WIDTH_MAX];
  bool flg;
  matrix<float> tmp(3,1);
  matrix<float> seq;
  SDL_LockSurface(cTerrainHoly);
  Uint32* myHoly=(Uint32*)(cTerrainHoly->pixels);
  c2=cLaserSpot.size[2];  
  while (jLaserList.token(seq)) {
    if (cMOVES_WIDTH_MIN<=seq.size[1]&&seq.size[1]<=cMOVES_WIDTH_MAX&&
        c2+seq.size[1]+1<cLaserSpot.size[2]+cLaserSpot.size[0]) {
      matrix<float> sek(3,seq.size[1]);
      for (c1=0;c1<seq.size[1];c1++) {
        sek.data[c1*3+0]=seq.data[c1*2+0];
        sek.data[c1*3+1]=seq.data[c1*2+1]+jLASER_OFFSET;
        sek.data[c1*3+2]=1.0f;
      }
      sek=cPos*sek;
      flg=true;
      tmp.data[0]=sek.data[0]+pPos.data[6];
      tmp.data[1]=sek.data[1]+pPos.data[7];
      tmp.data[2]=1;
      tmp=mMover->pos.solve(tmp);
      tmp.data[1]-=mTEASER_OFFSET;
      tmp.data[2]=0;
      flg=2.5f*mTEASER_RADIUS<tmp.norm(2);
      for (c1=0;c1<sek.size[1];c1++) {
        pix=(int)(jMAP_X+sek.data[c1*3+1]*jGND2MAP);
        piy=(int)(jMAP_Y+sek.data[c1*3+0]*jGND2MAP);
        pin=piy*jMAP_W+pix;
        buf[c1]=pin;
        flg&=0<pin&&pin<cTERRAIN;
        if (flg)
          flg&=myHoly[pin];
        else
          break;
      }
      if (flg) {
        for (c1=0;c1<sek.size[1];c1++)
          cLaserSpot.data[c2++]=buf[c1];
        cLaserSpot.data[c2++]=0;                                  // zero marks end of segment
      }
    }
  }
  SDL_UnlockSurface(cTerrainHoly);
  for (c1=c2;c1<cLaserSpot.size[2]+cLaserSpot.size[0];c1++)       // fill rest with ZEROS
    cLaserSpot.data[c1]=0;
  // END: a legend is born
  // BEGIN: intersection of two very different data structures, efficient  
  cMoves.numel=0;
  c2=cMOVES_SIZE1*3;
  for (c1=0;c1<c2;c1++)
    cMoves.data[c1]=0;
  SDL_LockSurface(cTerrainDiff);
  cMovements( cLaserSpot.size[2],          1,0xffff0000,5.0f);    // old free space INTERSECT new LASER POINTS
  c2 =cLaserSpot.size[2]+cLaserSpot.size[0];  
  cMovements(c2%cLaserSpot.numel,cMOVES_MASK,0xff0000ff,1.0f);    // new free space INTERSECT old LASER POINTS
  cMoves.size[1]=cMoves.numel/3;
  SDL_UnlockSurface(cTerrainDiff);
  // END: intersection of two very different data structures, efficient  
}


// direction for robot to back up
// aim is in MAP/GLOBAL coordinates (not robot)
matrix<float> cLookInto(int deg,float aix,float aiy) {
  jDEBUG("cLookinto")
  int c1;
  int pix,piy,pin;
  float len,ref=0;
  bool itr;
  matrix<float> dir(3,1),ray;
  matrix<float> rot(3,3,"eye");
  matrix<float> ret(3,1);
  dir.data[0]=aix;
  dir.data[1]=aiy;
  if (dir.norm(2)<0.01f) {
    jDeclared.prepend(new std::string("sick bastard"));
    return ret;
  }
  dir.normalize(2);                   // should be obsolete  
  for (c1=-deg;c1<=deg;c1+=5) {       // window of 60 degree total
    rot.data[0]= cos(c1*jDEG2RAD);
    rot.data[1]= sin(c1*jDEG2RAD);
    rot.data[3]=-rot.data[1];
    rot.data[4]= rot.data[0];
    ray=rot*dir;
    jDraw(jIN_MAP,&cPos.data[6],ray.data,0xffff0000,1.0f);
    len=0;  // for each direction start from len = 0, otherwise might route around obstacles
    itr=true;
    while (itr) {
      len+=jMAP2GND;
      rot.data[6]=cPos.data[6]+ray.data[0]*len;
      rot.data[7]=cPos.data[7]+ray.data[1]*len;
      pix=(int)(jMAP_X+rot.data[7]*jGND2MAP);
      piy=(int)(jMAP_Y+rot.data[6]*jGND2MAP);
      pin=piy*jMAP_W+pix;
      if (itr=0<pin&&pin<cTERRAIN)
        itr&=cDensity[pin];
      if (!itr)
        if (ref<len) {
          ret=ray*len;
          ref=len;
        }
    }
  }
  matrix<float> loc(3,1);
  loc.data[0]=cPos.data[6]+ret.data[0];
  loc.data[1]=cPos.data[7]+ret.data[1];
  jDraw(jIN_MAP,loc.data,1,0xffff0000,&filledEllipseRGBA);
  jDEBUG("exit cLookinto")
  return ret;
}
