// code by jph

#define                 jCLOCK_FUNC               SDL_GetTicks()
                        
#define                 jGESTURE_NONE           0
#define                 jGESTURE_CIRC           1
#define                 jGESTURE_WAVE           2
#define                 jGESTURE_MOON           3
#define                 jGESTURE_FOUR           4

#define                 jBUMPER_SENSING         0
#define                 jBUMPER_COUNTING        1
#define                 jBUMPER_FRONT           1
#define                 jBUMPER_LEFT            2
#define                 jBUMPER_BACK            4
#define                 jBUMPER_RIGHT           8
#define                 jBUMPER_ONCE            2         // press and release = 1+1
#define                 jBUMPER_TWICE           4
#define                 jBUMPER_THRICE          6

#define                 jAXIS_OFFSET            0.060f
#define                 jPTU_OFFSET             0.150f

#define                 jONE_HOUR               3600000   // 1 stunde
#define                 jROLLOUT                3500
#define                 jPOWER_DRIVE            2400000
#define                 jPOWER_CHARGE           600000
#define                 jPOWER_TOLERANCE        60000
#define                 jSHUTDOWN_DELAY         (3000*jTog[jTOG_MBOT_IGNITED])
                                                
#define                 jLASER                  181       // numel by GIM interface
#define                 jLASER_OFFSET           0.145f    // offset of laser from center of drive axis
#define                 jLASER_TANGENS          0.03f
#define                 jLASER_SAMPLING         0.04f
#define                 jLASER_SAMPLES          1024
#define                 jLASER_SPOTS            100
#define                 jLASER_IGNORE           10.0f     // ignore laser point further away than IGNORE
                                                
#define                 jMARKER_M               250.0f
#define                 jMARKER_R               50.0f
#define                 jMARKER_P               10.0f
                        
#define                 jPINS                   20         // max number of stones per picture
#define                 jROBOT_RADIUS           0.225f
#define                 jHUMAN_RADIUS           0.25f      // to clear terrain in map
#define                 jHUMAN_HEIGHT           1.40f      // to clear terrain in map
#define                 jSPEED_MEDIAN           3

#define                 jSPEED0_KEY             0.30f     // 0.40f
#define                 jSPEED0_JOY             0.40f     // 0.40f
#define                 jSPEED0_SLW             0.25f     // default ahead speed
#define                 jSPEED_ADD_NOISE        0.08f     // speed beyond which we add noise to deactivate server protection
#define                 jSPEED1_STD             0.50f
#define                 jSPEED0_LIM             0.45f     // these absolute limits are relevant for jLOCALIZE
#define                 jSPEED1_LIM             1.00f     // these absolute limits are relevant for jLOCALIZE

#define                 jSPEED_BLUR             0.50f
#define                 jPTUPAN_MIN            -1.57f
#define                 jPTUPAN_MAX             1.57f
#define                 jPTUPAN_RAD             0.06f
#define                 jPTUTIL_MIN            -1.40f
#define                 jPTUTIL_SAFETOWAVE     -1.10f
#define                 jPTUTIL_GESTURE_MIN    -0.50f
#define                 jPTUTIL_GESTURE        -0.15f     // default value
#define                 jPTUTIL_GESTURE_MAX     0.20f
#define                 jPTUTIL_NOOP            0.50f     // default value
#define                 jPTUTIL_STOPPED_BIAS   -0.10f     // default value
#define                 jPTUTIL_ABASHED         0.75f     // default value
#define                 jPTUTIL_PROFILE_MIN     1.00f
#define                 jPTUTIL_PROFILE         1.125f    // default value
#define                 jPTUTIL_MAX             1.25f

#define                 jTIP_OFFSET             0.4f
#define                 jCAMERA                 76800
#define                 jCAMERA3                230400
#define                 jCAMERA_COVERED         8.0f
#define                 jCAMERA_HEIGHT          0.75f
#define                 jPALETTE                35839     // 13417 47221 53783
#define                 jPALETTE_EMPTY          jPalette.empty(); SDL_FillRect(jPaletteDraw,NULL,0); SDL_FillRect(jCamera,NULL,0)
#define                 jCAMERA_MONO            1         // 0 or 1 selects left or right camera
#define                 jDEG2RAD                0.0174533
#define                 jRAD2DEG                57.295779
#define                 jPERMILLE               0.001
#define                 jEPS                    0.0001
#define                 jM_PI                   3.141592
#define                 jM_PI2                  1.570796
#define                 jDISPLAY_GAIN           1000

#define                 jJOYSTICK_FACTOR        0.000030525f
#define                 jJOYSTICK_DEADZONE      0.2f      // for a low quality joystick

#define                 jGESTURE                45
#define                 jGESTURE_INTERRUPT      750
#define                 jGESTURE_RANGEMIN       40
#define                 jGESTURE_REQUIRED       6

// BEGIN: constants, defined once and then left alone
SDL_PixelFormat         jSDL_PixelFormat;                 // pixel format for all SDL_Surfaces that we create
int                     jFOV=0;                           // later the number of points of the field-of-view polygon
int                     jFoV[128];                        // space for the field-of-view polygon
matrix<float>           jCamL2gnd(10,6);                  // for camera <-> ground conversion
matrix<float>           jCamR2gnd(10,6);                  // for camera <-> ground conversion
matrix<float>           jGnd2camL(10,6);                  // for camera <-> ground conversion
matrix<float>           jGnd2camR(10,6);                  // for camera <-> ground conversion
array<float>            jRandu;                           // uniform random numbers accessed by periodic tokenizer
array<float>            jRandn;                           // normal random numbers accessed by periodic tokenizer
array<bool>             jFlashingLaser,jShiningLaser;
array<bool>             jFlashingLight,jShiningLight;
matrix<float>           jCam(3,3,"eye");
matrix<float>           jCin;
int                     jRouteOfs[16];
float                   jRouteFac[16];
matrix<float>           jGestureX(4,20);
matrix<float>           jGestureY(4,20);
// END: constants, defined once and then left alone

// BEGIN: globals
char                    jChar[250];
SDL_Surface*            jCamera;
int                     jCameraMask[jCAMERA];
sutree<int>*            jCameraTree[jCAMERA];
unsigned int            jCameraRGB[jCAMERA3];             // less than 1 MB of mem
float                   jCameraBrightness=80.0f;          // holds number between 0...255
SDL_Surface*            jGoggle;                          
SDL_Surface*            jBuffer=NULL;                     // holds previous image
int                     jBumperOld=0;                     
int                     jBumper;                          // bit mask
int                     jBumperCount=0;                   // this is non-zero DURING ONE ITERATION (ingenious!) after bumper pressed several good old times ...
int                     jBumperLast =0;                   // this is the last jBumper!=0 value, when jBumperCount is released
// END: globals                                           
                                                          
// BEGIN: sensors                                         
matrix<float>           jLaser(2,jLASER);                 // 181 native laser points in laser coordinates, used in jExplode
matrix<float>           jLaserLocal(3,jLASER);            // 181 native laser points in local coordinates, best choice for cLocalize
linked<matrix<float> >  jLaserList;                       // groups of resampled laser points in laser coordinates
                                                          
matrix<float>           jSight[2];                        // true field-of-view in local coordinates
float                   jHazard;
matrix<float>           jMarker(4,4);
linked<int>             jGesture;
int                     jGestureLast=0;                   // set to ZERO if command has been executed!
matrix<float>           jGestureResX(4,1);
matrix<float>           jGestureResY(4,1);
matrix<float>           jStone(3,jPINS);
// END: sensors

// vel and acc monitor ---------------------------------------
#define                 jMSEC2PIX               0.01f     // sampling time for speed monitor
struct                  jMoniton {
  int stamp;
  matrix<float> data;
};
linked<jMoniton>        jMonitor;
SDL_Surface*            jMonitos;
SDL_Joystick            *jJoystick=0;
matrix<float>           jAxis(4,1);
matrix<int>             jButton(10,1);
matrix<int>             jMouse(2,1);

// palette  ---------------------------------------------------
unsigned int            jPaletteHash(unsigned int col) { return (col&0xffffff)%jPALETTE; }
hash<unsigned int,unsigned int> jPalette(jPALETTE,jPaletteHash);
SDL_Surface*            jPaletteDraw;

struct                  jPlanon {
  bool                    planned;                      // general status of path
  linked<int>             list;                         // pixel number in map of path
  float                   dist;                         // distance to goal as measured by path
  float                   safe;                         // j2b2 can drive faster for greater safe, used also as segment distance length  
  int                     count;                        // just for drawing
  matrix<float>           compass;                      // map coordinates !? (i am stupid)
};

void jDrawPlan(jPlanon& plan);

struct                  jPresson {
  matrix<float>           frame;
  float                   bot;
  float                   top;
  int                     type;
};

#define                 jMOVITON_ID_UNKNOWN       0
#define                 jMOVITON_ID_HUMAN         1
#define                 jMOVITON_ID_J2B2          2
#define                 jMOVITON_ID_MARSOKHOD     3

struct                  jMoviton {                      // structure to store humans, and stones, ...
  int                     id;                           // id: UNKNOWNs are handled by pMovements and pMovers ONLY, HUMANs are handled by whatever
  int                     stamp;                        // last move commanded/detected
  int                     visual;                       // now if human/robot in laser sight
  matrix<float>           pos;                          // 3x3 position in atlas=most globalst great truth coordinates
  linked<matrix<float> >  track;                        // 3x3 previous positions (most recent is first element)
  matrix<float>           ini;                          // 3x1 initial position, used to decide if "unknown" becomes "human"
  matrix<float>           add;                          // (PROTECTED) 3x1 used in pMovements
  jPlanon                 plan;
  jPlanon                 idea;
  int                     active;                       // 1 if moviton potentially moves, 0 when "parked"
  matrix<float>           rested;
  matrix<float>*          contour;                      // pointer to contour matrix (in local coordinates) to render moviton in map
};

// BEGIN: actuators and sensors
jMoviton*               jMover;
matrix<float>           jSetSpeed(2,1);                   // speed set by the planner
matrix<float>           jGetSpeed(2,1);                   // final speed
matrix<float>           jSetPTU(2,1);                     
matrix<float>           jOldPTU(2,1);                     // stores old PTU to introduce delay if changed
matrix<float>           jSetPTUBias(2,1);                 
matrix<float>           jOldPTUBias(2,1);                 // stores old PTU to introduce delay if changed
float                   jBoost=1.0f;                      
matrix<float>           jVel(3,1);                        // this is local information, ccode writes into this! first col = localize algoritgn, sec col is odometry
linked<matrix<float> >  jVelMedian;
// END: actuators


// BEGIN: internal timers all integers representing MILLISECONDS
#define                 jREGISTER                 48
int                     jTic[jREGISTER];
#define                 jTOC_LAST_SENSORS         0       // master timer counter
#define                 jTOC_LAST_SLAM            1       // localize for speed
#define                 jTOC_LAST_BUMPER          2       
#define                 jTOC_NEXT_PTU             3       // next PTU move
#define                 jTOC_NEXT_SPEAK           4       
#define                 jTOC_NEXT_PROFILE         5       // next profile of the same spot 
#define                 jTOC_NEXT_SCREENSHOT      6       // next shot?
#define                 jTOC_NEXT_EXTRAPOLATION   7       // for velocity estimation, very good trick!
#define                 jTOC_TIME_ROUTING         8
#define                 jTOC_TIME_LOCALIZE        9
#define                 jTOC_NEXT_TRACKING        10
#define                 jTOC_NEXT_STATE           11      // next shot?
#define                 jTOC_NEXT_FADING          12
#define                 jTOC_NEXT_NAVIGATION      13
#define                 jTOC_NEXT_SPLINT          14
#define                 jTOC_NEXT_JOKER_REGISTER  15
#define                 jTOC_STOP_GESTURE         16
#define                 jTOC_TIME_ROUTING2        18
#define                 jTOC_STOP_ALIGNING        19
#define                 jTOC_STOP_JOKER           20    // used by mcode
#define                 jTOC_STOP_AURORA          21
#define                 jTOC_STOP_BACKUP          22
#define                 jTOC_STOP_MBOT_TARGET     23
#define                 jTOC_STOP_MBOT_TOLERATE   24
#define                 jTOC_NEXT_ELONGATE        28
#define                 jTOC_NEXT_SPIN            30
#define                 jTOC_NEXT_SHUTDOWN        32    // delays program termination so that marsokhod has time to reconfigure
#define                 jTOC_STOP_FOLLOW          33
#define                 jTOC_NEXT_JOKER           34    // used by pcode
#define                 jTOC_NEXT_STARDUST        35
#define                 jTOC_NEXT_GENERAL_PURPOSE 37
#define                 jTOC_NEXT_RECHARGE        38
#define                 jTOC_NEXT_LOOKAROUND      39
#define                 jTOC_NEXT_DOWNLINK        40

bool                    jTog[jREGISTER];
#define                 jTOG_OBSTACLE_AVOIDANCE   0
#define                 jTOG_IOPIN_LASER          1
#define                 jTOG_IOPIN_LIGHT          2
#define                 jTOG_GLOBAL_RECORD        4
#define                 jTOG_PROFILE_EQUALIZED    6
#define                 jTOG_BUMPER_COUNTING      7
#define                 jTOG_JOYSTICK             9
#define                 jTOG_MOTION_DETECTED      11
#define                 jTOG_STONED_DETECTED      12
#define                 jTOG_MARKER_CALIBRATION   13
#define                 jTOG_HEAVY_DUTY           14
#define                 jTOG_ATLAS_CALIBRATE      15
#define                 jTOG_ATLAS_CALIBRATED     16
#define                 jTOG_LOOKING_FOR_HUMAN    17
#define                 jTOG_ALIGN_MBOT           18
#define                 jTOG_MOUSE_MIDDLE         19
#define                 jTOG_SPACE_DOWN           20
#define                 jTOG_POWER_SAVE           21
#define                 jTOG_FRESH_TRACKING       24
#define                 jTOG_MBOT_IGNITED         26
#define                 jTOG_MBOT_ELONGATE        27
#define                 jTOG_JBOT_HAUS            36

int                     jInt[jREGISTER];
#define                 jINT_MARKER_PIN           0
#define                 jINT_BUMPER_COUNT         1
#define                 jINT_TRACKING_LENGTH      2
#define                 jINT_TRACKING_SEGMENT     3
#define                 jINT_POWER_DRAIN          14
#define                 jINT_STATE_REGISTER       15
#define                 jINT_SNIPPET_ROBOT        16      // counting frames during screen recording
#define                 jINT_SNIPPET_MOVER        17      // counting frames during screen recording
#define                 jINT_STARDUST_LANE        19
// END: internals

// BEGIN: language department
struct                  jSpeakon {
  int                   typ;                              // mask for explain, problem, ...
  int                   stamp;                            // last spoken
  int                   period;                           // max repetition
  int                   flash;                            // number of flashes with light
  array<std::string*>   text;                             // 3x1 (PROTECTED) used in pMovements
  std::string*          appendix;                         // appendix
};

#define                 jSPEAK_TYPE_PROBLEM       1
#define                 jSPEAK_TYPE_EXPLAIN       2
#define                 jSPEAK_TYPE_LEISURE       4

#define                 jSPEAK_IDLE               0
#define                 jSPEAK_WELCOME            1
#define                 jSPEAK_HIDESEEK           2
#define                 jSPEAK_WAY                3
#define                 jSPEAK_NOWAY              4
#define                 jSPEAK_TARGET             5
#define                 jSPEAK_ARRIVAL            6
#define                 jSPEAK_GIVEUP             7
#define                 jSPEAK_FINISH             8
#define                 jSPEAK_SELECT             9
#define                 jSPEAK_GESTURE            10
#define                 jSPEAK_SHUTTER            11
#define                 jSPEAK_LASER              12
#define                 jSPEAK_DRAGFURTHER        13
#define                 jSPEAK_NOTSTOPPED         14
#define                 jSPEAK_RECHARGE           15
#define                 jSPEAK_POWERME            16

int                     jSpeakTypes=jSPEAK_TYPE_EXPLAIN|jSPEAK_TYPE_PROBLEM;
jSpeakon                jSpeak[jREGISTER];
// END: language department

#include "jsensor.cpp"

void jInit(void) {
  jDEBUG("jInit")
  int c1,c2;
  double ang;
  
  c1=181;
  jRandu=array<float>(1,&c1,0);
  jRandn=array<float>(1,&c1,0);
  
  #include "jconst.c"
  #include "jspeak.c"
  
  jCamera=SDL_CREATERGBSURFACE(320,240);                    // for drawing
  jGoggle=SDL_CREATERGBSURFACE(320,240);                    // for drawing
  jMonitos=SDL_CREATERGBSURFACE(320,200);                   // for drawing
  jPaletteDraw=SDL_CREATERGBSURFACE(jPALETTE_W,jPALETTE_H); // for drawing
  
  matrix<unsigned int> pal("sav/palette.mat");
  if (pal.data) {
    for (c1=0;c1<pal.numel;c1++)
      if (pal.data[c1]&&pal.data[c1]!=0xffffffff)
        jPalette.store(pal.data[c1],pal.data[c1]);  
    jPaletteUpdate();
  }
  
  for (c1=0;c1<jSPEED_MEDIAN;c1++)
    jVelMedian.append(matrix<float>(3,1));
  
  jSetPTU.data[0]=0.000f;
  jSetPTU.data[1]=jPTUTIL_NOOP;
  
  wCam2gnd[0]=matrix<float>(3,5); wCam2gnd[0].data[14]=1;   // matrices for conversion
  wCam2gnd[1]=matrix<float>(3,5); wCam2gnd[1].data[14]=1;
  wGnd2cam[0]=matrix<float>(2,5);
  wGnd2cam[1]=matrix<float>(2,5);
  
  jSight[0]=matrix<float>(3,jFOV,"ones");
  jSight[1]=matrix<float>(3,jFOV,"ones");
  
  for (c1=0;c1<jREGISTER;c1++) {
    jTic[c1]=0;
    jTog[c1]=false;
    jInt[c1]=0;
  }
  jTic[jTOC_NEXT_SHUTDOWN]=jONE_HOUR;
  jTic[jTOC_NEXT_RECHARGE]=jPOWER_DRIVE;                    // 20 minutes
  jTic[jTOC_NEXT_SCREENSHOT]=jONE_HOUR;
  jTog[jTOG_OBSTACLE_AVOIDANCE]=true;
  jTog[jTOG_PROFILE_EQUALIZED]=true;
  
  c1=16;
  jFlashingLaser=array<bool>(1,&c1,false);
  jFlashingLaser.data[ 1]=true;
  jFlashingLaser.data[ 3]=true;
  jFlashingLaser.data[ 5]=true;
  jFlashingLaser.data[ 7]=true;
  jFlashingLaser.data[ 9]=true;
  jFlashingLaser.data[11]=true;
  jFlashingLaser.data[13]=true;
  jFlashingLaser.data[15]=true;
  jFlashingLight=jFlashingLaser;
  
  jShiningLaser=array<bool>(1,&c1,true);
  jShiningLaser.data[0]=false;  
  jShiningLight=jShiningLaser;
  
  matrix<float> tmp("sav\\marker.mat");        // load from file
  if (tmp.data)
    for (c1=0;c1<16;c1++)
      jMarker.data[c1]=tmp.data[c1];
      
  if (0<SDL_NumJoysticks()) {
    jJoystick=SDL_JoystickOpen(0);
    if (SDL_JoystickNumAxes(jJoystick)<jAxis.numel||SDL_JoystickNumButtons(jJoystick)<jButton.numel)
      jJoystick=0;
  }
    
  jMover=new jMoviton;
  jMover->id=jMOVITON_ID_J2B2;
  jMover->pos=matrix<float>(3,3,"eye");
  jMover->active=1;
  jMover->contour=new matrix<float>(3,10);    // pointer to contour matrix (in local coordinates)  
  jMover->contour->numel=0;
  for (c1=0;c1<jMover->contour->size[1];c1++) {
    ang=c1*360*jDEG2RAD/jMover->contour->size[1];
    jMover->contour->data[jMover->contour->numel++]=jROBOT_RADIUS*cos(ang);
    jMover->contour->data[jMover->contour->numel++]=jROBOT_RADIUS*sin(ang)+jAXIS_OFFSET;
    jMover->contour->data[jMover->contour->numel++]=1;
  }
}

// manual steering and control of PTU
void jProcess(SDL_Event &mySDL_Event) {
  jDEBUG("jProcess");
  if (mySDL_Event.type==SDL_KEYDOWN) {
    switch (mySDL_Event.key.keysym.sym) {
      case SDLK_ESCAPE: jTic[jTOC_NEXT_SHUTDOWN]=jTic[jTOC_LAST_SENSORS];   break;
      case SDLK_UP:     jSetSpeed.data[0]= jSPEED0_KEY;                     break;
      case SDLK_DOWN:   jSetSpeed.data[0]=-jSPEED0_KEY;                     break;
      case SDLK_LEFT:   jSetSpeed.data[1]= jSPEED1_STD;                     break;
      case SDLK_RIGHT:  jSetSpeed.data[1]=-jSPEED1_STD;                     break;
      case SDLK_b:      jTog[jTOG_BUMPER_COUNTING]=!jTog[jTOG_BUMPER_COUNTING];         break;
      case SDLK_c:      jTog[jTOG_MARKER_CALIBRATION]=!jTog[jTOG_MARKER_CALIBRATION];   break;
      case SDLK_j:      jTog[jTOG_JOYSTICK]=jJoystick&&!jTog[jTOG_JOYSTICK];            break;
      case SDLK_l:      jTog[jTOG_IOPIN_LIGHT]=!jTog[jTOG_IOPIN_LIGHT]; jTog[jTOG_IOPIN_LASER]=!jTog[jTOG_IOPIN_LASER]; break;
      case SDLK_s:      jTic[jTOC_NEXT_SCREENSHOT]=0;                       break;
      case SDLK_t:      jSpeaks("one two three, test, 1 2.5 30");           break;
      case SDLK_x:      jPALETTE_EMPTY;                                     break;
      case SDLK_z:      jTog[jTOG_OBSTACLE_AVOIDANCE]=false;                break;
  	}
  }
  if (mySDL_Event.type==SDL_KEYUP) {
    switch (mySDL_Event.key.keysym.sym) {
      case SDLK_UP:     jSetSpeed.data[0]=0.0f;                             break;
      case SDLK_DOWN:   jSetSpeed.data[0]=0.0f;                             break;
      case SDLK_LEFT:   jSetSpeed.data[1]=0.0f;                             break;      
      case SDLK_RIGHT:  jSetSpeed.data[1]=0.0f;                             break;
  	  case SDLK_z:      jTog[jTOG_OBSTACLE_AVOIDANCE]=true;                 break;
    }
  }
  if (mySDL_Event.type==SDL_MOUSEBUTTONDOWN) {
    int pix=mySDL_Event.button.x;
    int piy=mySDL_Event.button.y;
    if (jBAR_BOOST_X<pix&&pix<jBAR_BOOST_X+jBAR_W&&jBAR_BOOST_Y<piy&&piy<jBAR_BOOST_Y+jBAR_H)
      jBoost=(pix-jBAR_BOOST_X)/(float)jBAR_W;
    if (jBAR_PTUPAN_X<pix&&pix<jBAR_PTUPAN_X+jBAR_W&&jBAR_PTUPAN_Y<piy&&piy<jBAR_PTUPAN_Y+jBAR_H)
      jSetPTU.data[0]=(pix-jBAR_PTUPAN_X)*(jPTUPAN_MAX-jPTUPAN_MIN)/(float)jBAR_W+jPTUPAN_MIN;
    if (jBAR_PTUTIL_X<pix&&pix<jBAR_PTUTIL_X+jBAR_W&&jBAR_PTUTIL_Y<piy&&piy<jBAR_PTUTIL_Y+jBAR_H)
      jSetPTU.data[1]=(pix-jBAR_PTUTIL_X)*(jPTUTIL_MAX-jPTUTIL_MIN)/(float)jBAR_W+jPTUTIL_MIN;
    if (jBAR_MARKER_M<pix&&pix<jBAR_MARKER_M+jBAR_W&&jBAR_MARKER_Y<piy&&piy<jBAR_MARKER_Y+jBAR_H)
      jMarker.data[12]=(pix-jBAR_MARKER_M)*jMARKER_M/(float)jBAR_W;
    if (jBAR_MARKER_R<pix&&pix<jBAR_MARKER_R+jBAR_W&&jBAR_MARKER_Y<piy&&piy<jBAR_MARKER_Y+jBAR_H)
      jMarker.data[13]=(pix-jBAR_MARKER_R)*jMARKER_R/(float)jBAR_W;
    if (jBAR_MARKER_P<pix&&pix<jBAR_MARKER_P+jBAR_W&&jBAR_MARKER_Y<piy&&piy<jBAR_MARKER_Y+jBAR_H)
      jMarker.data[14]=(pix-jBAR_MARKER_P)*jMARKER_P/(float)jBAR_W;                  
    if (jHUD_CAMERA_X<pix&&pix<jHUD_CAMERA_X+320&&jHUD_CAMERA_Y<piy&&piy<jHUD_CAMERA_Y+240&&camera)
      jMarkerSet(pix-jHUD_CAMERA_X,piy-jHUD_CAMERA_Y);
  }
  if (mySDL_Event.type==SDL_MOUSEMOTION) {
    jMouse.data[0]=mySDL_Event.motion.x;
    jMouse.data[1]=mySDL_Event.motion.y;            
  }
  
}

void jControl(void) {
  jDEBUG("jControl")
  int c1,cnt,pin;
  if (jSpeak[jSPEAK_RECHARGE].appendix)
    delete jSpeak[jSPEAK_RECHARGE].appendix;
  sprintf(jChar,"%i minutes.",(jTic[jTOC_NEXT_RECHARGE]-jTic[jTOC_LAST_SENSORS])/60000);
  jSpeak[jSPEAK_RECHARGE].appendix=new std::string(jChar);
  // BEGIN: PTU control
  float nrm;
  jSetPTUBias.data[1]=(jPTUTIL_GESTURE_MAX<jSetPTU.data[1]+jPTUTIL_STOPPED_BIAS&&jSetPTU.data[1]<jPTUTIL_PROFILE_MIN&&jMover->stamp+jROLLOUT<jTic[jTOC_LAST_SENSORS])*jPTUTIL_STOPPED_BIAS;
  jSetPTU.data[0]=MAX(jPTUPAN_MIN,jSetPTU.data[0]);
  jSetPTU.data[0]=MIN(jPTUPAN_MAX,jSetPTU.data[0]);
  jSetPTU.data[1]=MAX(jPTUTIL_MIN,jSetPTU.data[1]);
  jSetPTU.data[1]=MIN(jPTUTIL_MAX,jSetPTU.data[1]);  
  nrm=(jSetPTU-jOldPTU).norm(2)+(jSetPTUBias-jOldPTUBias).norm(2);
  if (4*jDEG2RAD<nrm&&jTic[jTOC_NEXT_PTU]<jTic[jTOC_LAST_SENSORS]) {
    jOldPTU    =jSetPTU;
    jOldPTUBias=jSetPTUBias;
    ctrl.PTU_TurnTo(jSetPTU.data[0]+jSetPTUBias.data[0],
                    jSetPTU.data[1]+jSetPTUBias.data[1]); // bia is in god mode
    jTic[jTOC_NEXT_PROFILE]=0;
    jTic[jTOC_STOP_GESTURE]=0;
    jTic[jTOC_NEXT_PTU]=jTic[jTOC_LAST_SENSORS]+(int)(300*(nrm+1));
  }
  // END: PTU control
  // BEGIN: gesture recognition
  cnt=0;
  while (jGesture.token(pin))
    cnt++;
  if ((jTic[jTOC_STOP_GESTURE]<jTic[jTOC_LAST_SENSORS]||jGESTURE<=cnt)        // gesture finished or exeeds length
      &&cnt) {                                                                // a little help
    jTic[jTOC_STOP_GESTURE]=0;                                                // not sure if that is required!?!
    //if (jGestures())
    //  jFLASH_LIGHT(jGestureLast);
  }
  // END: gesture recognition
  if (jTog[jTOG_JOYSTICK]) {
    jSetSpeed.data[0]=jAxis.data[2]*jSPEED0_JOY;
    jSetSpeed.data[1]=jAxis.data[3]*jSPEED1_STD;
    sprintf(jChar,"joystick %6.3f %6.3f %6.3f %6.3f ",jAxis.data[0],jAxis.data[1],jAxis.data[2],jAxis.data[3]);
    jBulletin.append(new std::string(jChar));
    for (c1=0;c1<jButton.numel;c1++) {
      sprintf(jChar," button %d -> %d",c1,jButton.data[c1]);
      jBulletin.append(new std::string(jChar));
    }
  }
  // BEGIN: speed control and obstacle avoidance  
  float spd0=jSetSpeed.data[0];               // boost and add noise to prevent motors to shut down
  float spd1=jSetSpeed.data[1];  
  if (jTog[jTOG_OBSTACLE_AVOIDANCE])
    jBoost=MIN(MAX(0.20f,jHazard),1.0f);  
  spd0=MIN(MAX(-jSPEED0_LIM,spd0),jSPEED0_LIM*jBoost);
  spd1=MIN(MAX(-jSPEED1_LIM,spd1),jSPEED1_LIM);  
  if (jSPEED_ADD_NOISE<fabs(spd0)) spd0+=jRandn.token()*0.005;
  if (jSPEED_ADD_NOISE<fabs(spd1)) spd1+=jRandn.token()*0.005;  
  if (jTog[jTOG_OBSTACLE_AVOIDANCE]&&jBumper)
    spd0=spd1=0;
  spd0*=jMover->active;
  ctrl.ASRobo_SetSpeed(jGetSpeed.data[0]=spd0,jGetSpeed.data[1]=spd1);
  // END: speed control and obstacle avoidance
  // BEGIN: parasites of speed control
  if (0<jGetSpeed.norm(2))                                      // stamps time of last active control
    jMover->stamp=jTic[jTOC_LAST_SENSORS];    
  if (jInt[jINT_POWER_DRAIN]=(int)(jGetSpeed.norm(2)*550))      // zero when slow down or stopped
    jTic[jTOC_NEXT_RECHARGE]-=jInt[jINT_POWER_DRAIN];
  // END: parasites of speed control
  // BEGIN: active optics
  ctrl.ASRobo_IO_SetPin(ASROBO_IOPIN_LIGHT,jTog[jTOG_IOPIN_LASER]^jFlashingLaser.token(-1)^jShiningLaser.token(-1));   // sets LASER
  ctrl.ASRobo_IO_SetPin(ASROBO_IOPIN_LASER,jTog[jTOG_IOPIN_LIGHT]^jFlashingLight.token(-1)^jShiningLight.token(-1));
  // END: active optics
}


void jHUD(void) {
  jDEBUG("jHUD")
  int c1,c2,c3;
  Uint32 col;
  SDL_Rect mySDL_src;
  SDL_Rect mySDL_dst;  
  if (jTog[jTOG_MARKER_CALIBRATION])
    jBulletin.append(new std::string("calibrating palette (numbers)"));
  mySDL_src.x=0; mySDL_src.y=0; mySDL_src.h=jBAR_H;
  mySDL_src.w=112;
  SDL_FillRect(screen,&mySDL_src,SDL_MapRGBA(screen->format,64,64,64,255));
  sprintf(jChar,"T %3i:%2i:%3i",                                                        // overall time
     jTic[jTOC_LAST_SENSORS]/60000,
    (jTic[jTOC_LAST_SENSORS]/1000)%60,
     jTic[jTOC_LAST_SENSORS]%1000);
  jDrawString(screen,jFond,jChar,0,0);  
  mySDL_src.w=(int)(jBAR_W*MAX(0,jTic[jTOC_NEXT_RECHARGE]-jTic[jTOC_LAST_SENSORS])/jPOWER_DRIVE);
  mySDL_dst.x=jBAR_POWER_X;
  mySDL_dst.y=jBAR_POWER_Y;
  SDL_BlitSurface(jBarY,&mySDL_src,screen,&mySDL_dst);
  if (jInt[jINT_POWER_DRAIN]) {
    sprintf(jChar,"power -%i",jInt[jINT_POWER_DRAIN]);
    jDrawString(screen,jFonr,jChar,jBAR_POWER_X,jBAR_POWER_Y);  
  } else {
    sprintf(jChar,"%3i min",(jTic[jTOC_NEXT_RECHARGE]-jTic[jTOC_LAST_SENSORS])/60000);  // time to recharge
    jDrawString(screen,jFong,jChar,jBAR_POWER_X+jBAR_W-49,jBAR_POWER_Y);  
  }
  if (jTic[jTOC_NEXT_SHUTDOWN]<jTic[jTOC_LAST_SENSORS]) {
    sprintf(jChar,"shutting down in %6.3f sec",(jTic[jTOC_NEXT_SHUTDOWN]+jSHUTDOWN_DELAY-jTic[jTOC_LAST_SENSORS])*0.001f);
    jBulletin.append(new std::string(jChar));
  }
  if (jInt[jINT_BUMPER_COUNT]) {    
    sprintf(jChar,"bumper clicks %i\0",jInt[jINT_BUMPER_COUNT]);
    jBulletin.append(new std::string(jChar));
  }
  jDrawString(screen,jFont,"b",0,jBAR_BOOST_Y);	                                        // boost
  mySDL_src.w=(int)(jBAR_W*jBoost);
  mySDL_dst.x=jBAR_BOOST_X;
  mySDL_dst.y=jBAR_BOOST_Y;  
  SDL_BlitSurface(jBarR,&mySDL_src,screen,&mySDL_dst);
	sprintf(jChar,"%6.3f",jBoost);
	jDrawString(screen,jFont,jChar,jBAR_BOOST_X+jBAR_W/2-21,jBAR_BOOST_Y);
  mySDL_src.w=(int)(jBAR_W*(jSetPTU.data[0]+jM_PI2)/jM_PI);                             // camera pan tilt
  mySDL_dst.x=jBAR_PTUPAN_X;
  mySDL_dst.y=jBAR_PTUPAN_Y;
  SDL_BlitSurface(jBarO,&mySDL_src,screen,&mySDL_dst);
	sprintf(jChar,"%6.3f",jOldPTU.data[0]);
	jDrawString(screen,jFont,jChar,jBAR_PTUPAN_X+jBAR_W/2-21,jBAR_PTUPAN_Y);	
  mySDL_src.w=(int)(jBAR_W*(jSetPTU.data[1]-jPTUTIL_MIN)/(jPTUTIL_MAX-jPTUTIL_MIN));
  mySDL_dst.x=jBAR_PTUTIL_X;
  mySDL_dst.y=jBAR_PTUTIL_Y;
  SDL_BlitSurface(jBarO,&mySDL_src,screen,&mySDL_dst);
	sprintf(jChar,"%6.3f",jOldPTU.data[1]);
	jDrawString(screen,jFont,jChar,jBAR_PTUTIL_X+jBAR_W/2-21,jBAR_PTUTIL_Y);  
  mySDL_dst.y=jBAR_MARKER_Y;
  jDrawString(screen,jFont,"m",0,jBAR_MARKER_Y);
  mySDL_src.w=(int)(jBAR_W*jMarker.data[12]/jMARKER_M);
  mySDL_dst.x=jBAR_MARKER_M;
  SDL_BlitSurface(jBarG,&mySDL_src,screen,&mySDL_dst);
	sprintf(jChar,"%6.3f",jMarker.data[12]);
	jDrawString(screen,jFont,jChar,jBAR_MARKER_M+jBAR_W/2-21,jBAR_MARKER_Y);	
  mySDL_src.w=(int)(jBAR_W*jMarker.data[13]/jMARKER_R);
  mySDL_dst.x=jBAR_MARKER_R;
  SDL_BlitSurface(jBarG,&mySDL_src,screen,&mySDL_dst);
	sprintf(jChar,"%6.3f",jMarker.data[13]);
	jDrawString(screen,jFont,jChar,jBAR_MARKER_R+jBAR_W/2-21,jBAR_MARKER_Y);	
  mySDL_src.w=(int)(jBAR_W*jMarker.data[14]/jMARKER_P);
  mySDL_dst.x=jBAR_MARKER_P;
  SDL_BlitSurface(jBarG,&mySDL_src,screen,&mySDL_dst);
	sprintf(jChar,"%3.1f",jMarker.data[14]);
	jDrawString(screen,jFont,jChar,jBAR_MARKER_P+jBAR_W/2-7,jBAR_MARKER_Y);	
  // BEGIN: speed and accel monitor
  jMoniton tok;
  tok.stamp=jTic[jTOC_LAST_SENSORS];
  tok.data=matrix<float>(5,1);
  for (c1=0;c1<3;c1++)
    tok.data.data[c1]=jVel.data[c1];
  tok.data.data[3]=jGetSpeed.data[0];
  tok.data.data[4]=jGetSpeed.data[1];
  jMonitor.prepend(tok);  
  int dif,pix,piy;
  mySDL_src.w=2; mySDL_src.h=2;
  SDL_FillRect(jMonitos,NULL,0xfff0f0f0);
  int mCol[5*3]={255,0,0,
                 0,255,0,
                 0,0,255,
                 0,0,128,
                 128,0,0};
               // Va  Vx  Vy  Ax  Aa
  int mMag[5]  ={ 30,100,100, 30, 30};
  int mOfs[5]  ={ 61,136,137,135, 60};
  int len=(int)(jMonitos->w/jMSEC2PIX);
  for (c1=0;c1<5;c1++) {
    c3=c1*3;
    mySDL_src.x=0; mySDL_src.y=0;
    while (jMonitor.token(tok)) {
      dif=jTic[jTOC_LAST_SENSORS]-tok.stamp;
      if (dif<len)
        if (mySDL_src.x) {
          lineRGBA(jMonitos,
               mySDL_src.x,mySDL_src.y,
               pix=jMonitos->w-(int)(dif*jMSEC2PIX),
               piy=(int)(mOfs[c1]-tok.data.data[c1]*mMag[c1]),
               mCol[c3+0],mCol[c3+1],mCol[c3+2],255);
          mySDL_src.x=pix;
          mySDL_src.y=piy;
        } else {
          mySDL_src.x=jMonitos->w-(int)(dif*jMSEC2PIX);
          mySDL_src.y=(int)(mOfs[c1]-tok.data.data[c1]*mMag[c1]);          
        }
      else 
        jMonitor.remove();
    }
  }
  c1=0;
  while (jMonitor.token(tok)) {
    dif=jTic[jTOC_LAST_SENSORS]-tok.stamp;
    mySDL_src.x=jMonitos->w-(int)(dif*jMSEC2PIX);
    mySDL_src.y=0;
    mySDL_src.w=mySDL_src.h=1;
    SDL_FillRect(jMonitos,&mySDL_src,0xff808080);
  }
  sprintf(jChar,"Va %5.0f",jVel.data[0]*jDISPLAY_GAIN);
  jDrawString(jMonitos,jFont,jChar,214,0);
  sprintf(jChar,"Vx %5.0f\tVy %5.0f",jVel.data[1]*jDISPLAY_GAIN,jVel.data[2]*jDISPLAY_GAIN);
  jDrawString(jMonitos,jFont,jChar,214,178);
  sprintf(jChar,"Ax %5.0f",jGetSpeed.data[0]*jDISPLAY_GAIN);
  jDrawString(jMonitos,jFont,jChar,0,178);
  sprintf(jChar,"Aa %5.0f",jGetSpeed.data[1]*jDISPLAY_GAIN);
  jDrawString(jMonitos,jFont,jChar,0,0);  
  if (jMover->stamp+jROLLOUT<jTic[jTOC_LAST_SENSORS])
    jDrawString(jMonitos,jFont,"stopped",271,11);
  // END: speed and accel monitor  
  // BEGIN: gesture
  int pip,pin,cnt=1;
  if (jGesture.token(pip)) {
    while (jGesture.token(pin)) {
      lineRGBA(jCamera,pip%jCAMERA_W,pip/jCAMERA_W,pin%jCAMERA_W,pin/jCAMERA_W,0xff,0x40,0xff,0xff);
      pip=pin;
      cnt++;
    }
    sprintf(jChar,"%2i",cnt);
    jDrawString(jCamera,jFond,jChar,306,0);
  }
  // END: gesture  
  mySDL_src.x=jMouse.data[0]-jHUD_CAMERA_X;                       // if mouse on camera pic => display brightness
  mySDL_src.y=jMouse.data[1]-jHUD_CAMERA_Y;
  if (0<mySDL_src.x&&mySDL_src.x<jCAMERA_W&&
      0<mySDL_src.y&&mySDL_src.y<jCAMERA_H) {
    sprintf(jChar,"camera brightness %5.1f",jCameraBrightness);
    jBulletin.append(new std::string(jChar));
  }
}

void jShutdown(void) {    
  jDEBUG("jShutdown")
  if (SDL_JoystickOpened(0)&&jJoystick)
    SDL_JoystickClose(jJoystick);
}
