// code by jph

// jDrawString draws myString to mySDL_Surface at (x,y)
// tab character breaks line
void jDrawString(SDL_Surface* mySDL_Surface,SDL_Surface* myFont,const char* myString,int x,int y) {
  if (mySDL_Surface==NULL||myFont==NULL)
    return;
  int c1=0;
  SDL_Rect src,dst;
  src.x=src.y=0;
  src.w=7;
  src.h=11;
  dst.x=x;
  dst.y=y;
  while (myString[c1]) {
    if (myString[c1]=='\t') {      
      dst.x=x;
      dst.y+=11;
    } else {
      src.x=(myString[c1]-32)*7;
      SDL_BlitSurface(myFont,&src,mySDL_Surface,&dst);    
      dst.x+=7;
    }
    c1++;
  }
}

// draws frame around wld with WIDth and COLor
// takes world coordinates
void jDrawFrame(int mySDL_Surfaces,matrix<float> frm,Uint32 col) {
  int c1;
  int pin,pix,piy;
  int wid=3,wid2=1;
  SDL_Rect mySDL_Rect; mySDL_Rect.w=wid; mySDL_Rect.h=wid;
  if (mySDL_Surfaces&jIN_MAP) {
    pix=(int)(jMAP_X+frm.data[7]*jGND2MAP);
    piy=(int)(jMAP_Y+frm.data[6]*jGND2MAP);
    if (0<pix&&pix<jMAP_W&&0<piy&&piy<jMAP_H) {
      mySDL_Rect.x=(Uint16)pix-wid2;
      mySDL_Rect.y=(Uint16)piy-wid2;
	    SDL_FillRect(cMap,&mySDL_Rect,col);
      lineRGBA(cMap,pix,piy,(int)(pix+frm.data[1]*jVECTOR_M*jGND2MAP),(int)(piy+frm.data[0]*jVECTOR_M*jGND2MAP),255,  0,255,255);
      lineRGBA(cMap,pix,piy,(int)(pix+frm.data[4]*jVECTOR_M*jGND2MAP),(int)(piy+frm.data[3]*jVECTOR_M*jGND2MAP),  0,255,255,255);
    }
  }
}

// this jDraw serves functions &polygonRGBA and &filledPolygonRGBA
// only occurrence of function pointers in j2b2 operating system
void jDraw(int mySDL_Surfaces,const matrix<float> &map,Uint32 col,int (*func)(SDL_Surface*,const Sint16*,const Sint16*,int,Uint8,Uint8,Uint8,Uint8)) {
  jDEBUG("jDraw Polygon enter")
  int c1,c2;
  Uint8 r,g,b;
  SDL_GetRGB(col,&jSDL_PixelFormat,&r,&g,&b);
  Sint16 pix[map.size[1]];
  Sint16 piy[map.size[1]];    
  for (c1=0;c1<map.size[1];c1++) {
    pix[c1]=(Sint16)(jMAP_X+map.data[c1*3+1]*jGND2MAP);
    piy[c1]=(Sint16)(jMAP_Y+map.data[c1*3+0]*jGND2MAP);      
  }
  if (mySDL_Surfaces&jIN_MAP)
    func(cMap        ,pix,piy,map.size[1],r,g,b,255);    
  if (mySDL_Surfaces&jIN_TERRAINSTUB)
    func(cTerrainStub,pix,piy,map.size[1],r,g,b,255);
  if (mySDL_Surfaces&jIN_TERRAINTRIA)
    func(cTerrainTria,pix,piy,map.size[1],r,g,b,255);
  jDEBUG("jDraw Polygon exit")
}


// filled ellipse ...
void jDraw(int mySDL_Surfaces,float* wld,int rad,Uint32 col,int (*func)(SDL_Surface*,Sint16,Sint16,Sint16,Sint16,Uint8,Uint8,Uint8,Uint8)) {
  Uint8 r,g,b,a;
  int c1;
  int pin,pix,piy;
  SDL_GetRGBA(col,&jSDL_PixelFormat,&r,&g,&b,&a);  
  pix=(int)(jMAP_X+wld[1]*jGND2MAP);
  piy=(int)(jMAP_Y+wld[0]*jGND2MAP);
  if (mySDL_Surfaces&jIN_MAP)
    func(cMap,pix,piy,rad,rad,r,g,b,a);
  if (mySDL_Surfaces&jIN_TERRAINSTUB)
    func(cTerrainStub,pix,piy,rad,rad,r,g,b,255);
  if (mySDL_Surfaces&jIN_TERRAINTRIA)
    func(cTerrainTria,pix,piy,rad,rad,r,g,b,255);
}

void jDraw(int mySDL_Surfaces,float* wld,float* ray,Uint32 col,float sca) {
  Uint8 r,g,b,a;
  int pix,piy,pjx,pjy;
  SDL_GetRGBA(col,&jSDL_PixelFormat,&r,&g,&b,&a);  
  pix=(int)(jMAP_X+wld[1]*jGND2MAP);
  piy=(int)(jMAP_Y+wld[0]*jGND2MAP);
  pjx=(int)(jMAP_X+(wld[1]+sca*ray[1])*jGND2MAP);
  pjy=(int)(jMAP_Y+(wld[0]+sca*ray[0])*jGND2MAP);
  if (mySDL_Surfaces&jIN_MAP)
    lineRGBA(cMap,pix,piy,pjx,pjy,r,g,b,a);
}

// this jDraw writes the text directly to the coordinate systems
void jDraw(int mySDL_Surfaces,float* wld,char* myString) {
  int c1,pin;
  int pix,piy;  
  pix=(int)(jMAP_X+wld[1]*jGND2MAP)+3;
  piy=(int)(jMAP_Y+wld[0]*jGND2MAP)-5;
  if (0<pix&&pix<jMAP_W&&0<piy&&piy<jMAP_H)
    jDrawString(cMap,jFond,myString,pix,piy);  
}

// flush cameras, front, map onto screen
// record everything
void jDraw(void) {
  int c1,c2;
  SDL_Rect mySDL_Rect;
  
  mySDL_Rect.x=jHUD_MONITOR_X;
  mySDL_Rect.y=jHUD_MONITOR_Y;
  SDL_BlitSurface(jMonitos,NULL,screen,&mySDL_Rect);

  mySDL_Rect.x=jHUD_PALETTE_X;
  mySDL_Rect.y=jHUD_PALETTE_Y;
  SDL_BlitSurface(jPaletteDraw,NULL,screen,&mySDL_Rect);  
  
  mySDL_Rect.x=jHUD_MAP_X;
	mySDL_Rect.y=jHUD_MAP_Y;
	SDL_BlitSurface(cMap,NULL,screen,&mySDL_Rect);
	
	// BEGIN: export picture of j2b2 and marsokhod
	//if (pStates[pIndex]==pSTATE_MBOT_INTERPLAY) {
  //	mySDL_Rect.x=(int)(jHUD_MAP_X+jMAP_X+(mPos.data[7]*0.65f+cPos.data[7]*0.35f)*jGND2MAP)-115;
  //  mySDL_Rect.y=(int)(jHUD_MAP_Y+jMAP_Y+(mPos.data[6]*0.65f+cPos.data[6]*0.35f)*jGND2MAP)-87;
  //  SDL_BlitSurface(screen,&mySDL_Rect,pSnippet,NULL);
  //  sprintf(jChar,"out/mov/%05i.bmp",jInt[jINT_SNIPPET_MOVER]++);
  //  SDL_SaveBMP(pSnippet,jChar);
  //}
  // END: export picture of j2b2 and marsokhod
	
	// BEGIN: export picture of whats in front of robot
	//if (pStates[pIndex]==pSTATE_AFFECTION) {
  //	mySDL_Rect.x=(int)(jHUD_MAP_X+jMAP_X+(cPos.data[7]+cPos.data[4]*1.0f)*jGND2MAP)-115;
  //  mySDL_Rect.y=(int)(jHUD_MAP_Y+jMAP_Y+(cPos.data[6]+cPos.data[3]*1.0f)*jGND2MAP)-115; //-87;
  //  SDL_BlitSurface(screen,&mySDL_Rect,pSnippet,NULL);
  //  sprintf(jChar,"out/mov/%05i.bmp",jInt[jINT_SNIPPET_MOVER]++);
  //  SDL_SaveBMP(pSnippet,jChar);
  //}
  // END: export picture of whats in front of robot
  
	//if (jTog[jTOG_GLOBAL_RECORD]) {
  //	mySDL_Rect.x=(int)(jHUD_MAP_X+jMAP_X+cPos.data[7]*jGND2MAP)-115;
  //  mySDL_Rect.y=(int)(jHUD_MAP_Y+jMAP_Y+cPos.data[6]*jGND2MAP)-115;//87;
  //  SDL_BlitSurface(screen,&mySDL_Rect,pSnippet,NULL);
  //  sprintf(jChar,"out/rob/%05i.bmp",jInt[jINT_SNIPPET_ROBOT]++);
  //  SDL_SaveBMP(pSnippet,jChar);
  //}

  mySDL_Rect.y=jHUD_CAMERA_Y;
  if (jTog[jTOG_MARKER_CALIBRATION]) {
    mySDL_Rect.x=jHUD_CAMERA_X+jCAMERA_W;
    SDL_BlitSurface(jGoggle,NULL,screen,&mySDL_Rect);
    mySDL_Rect.x=jHUD_CAMERA_X;
    if (camera)
      SDL_BlitSurface(camera,NULL,screen,&mySDL_Rect);
  } else {
    mySDL_Rect.x=jHUD_CAMERA_X;
    SDL_BlitSurface(jGoggle,NULL,screen,&mySDL_Rect);
  }
  SDL_BlitSurface(jCamera,NULL,screen,&mySDL_Rect);
  
	SDL_FillRect(cMap,NULL,0);
	SDL_FillRect(jCamera,NULL,0);

  std::string* str;
  c1=jBULLETIN_Y;
  c2=0;
  while (jDeclared.token(str)) {
    jDrawString(screen,jFont,str->c_str(),jBULLETIN_X,c1);
    c1+=11;
    c2++;
    if (12<c2) {
      delete str;
      jDeclared.remove();
    }
  }
  c1+=3;
  while (jBulletin.token(str)) {
    jDrawString(screen,jFong,str->c_str(),jBULLETIN_X,c1);
    delete str;
    jBulletin.remove();
    c1+=11;
  }
  
  // BEGIN: downlink screen shot to client program
  //if ( jTic[jTOC_NEXT_DOWNLINK]<jTic[jTOC_LAST_SENSORS] && !jTog[jTOG_HEAVY_DUTY]) {
  // 	SDL_LockSurface(screen);
  // 	ctrl.GIMnet_SendMessage("j2b2ctrl_ground1",screen->pixels,jSCREEN_W*jSCREEN_H*screen->format->BytesPerPixel);
  // 	SDL_UnlockSurface(screen);
  // 	jTic[jTOC_NEXT_DOWNLINK]=jTic[jTOC_LAST_SENSORS]+1000;
  // 	jTog[jTOG_HEAVY_DUTY]=true;
  // 	jDrawString(screen,jFont,"D",cICON_DOWNLINK_X,cICON_Y);
  //} else
  //  jDrawString(screen,jFond,"D",cICON_DOWNLINK_X,cICON_Y);
  // END: downlink screen shot to client program
    
	if ( jTic[jTOC_NEXT_SCREENSHOT]<jTic[jTOC_LAST_SENSORS] && camera && !jTog[jTOG_HEAVY_DUTY] ) {
  	sprintf(jChar,"out/win/%07i.bmp",jTic[jTOC_LAST_SENSORS]/10);
  	SDL_SaveBMP(screen,jChar);
  	jTic[jTOC_NEXT_SCREENSHOT]=jTic[jTOC_LAST_SENSORS]+jONE_HOUR;   // practically no screen shots for safe driving
  	jTog[jTOG_HEAVY_DUTY]=true;
   	jDrawString(screen,jFont,"S",cICON_SCREENSHOT_X,cICON_Y);
  } else
    jDrawString(screen,jFond,"S",cICON_SCREENSHOT_X,cICON_Y);
	
  if (jTog[jTOG_HEAVY_DUTY])
    jDrawString(screen,jFond,"+",7,0);
}

void jDrawPlan(jPlanon& plan) {  // sad  
  jDEBUG("jDrawPlan")
  SDL_Rect mySDL_Rect;
  mySDL_Rect.w=mySDL_Rect.h=1;                        // plan
  int pin,c1=0;
  if (plan.planned) {
    jDEBUG("path planned")
    if (plan.list.token(pin))
      lineRGBA( cMap,
                pin%jMAP_W,
                pin/jMAP_W,
                pin%jMAP_W+(int)(plan.compass.data[1]*0.3f*jGND2MAP),
                pin/jMAP_W+(int)(plan.compass.data[0]*0.3f*jGND2MAP),255,255, 64,255);
    
    while (plan.list.token(pin)) {
      mySDL_Rect.x=pin%jMAP_W;
      mySDL_Rect.y=pin/jMAP_W;
      SDL_FillRect(cMap,&mySDL_Rect,0xf00040ff+((c1<plan.count)<<15));
      c1++;
    }
  }
  jDEBUG("jDrawPlan exit")
}

bool jAtlas2map(matrix<float> pnt,int& pix,int& piy) {
  pix=(int)(jMAP_X+(pnt.data[1]-pPos.data[7])*jGND2MAP);
  piy=(int)(jMAP_Y+(pnt.data[0]-pPos.data[6])*jGND2MAP);
  return 0<pix&&pix<jMAP_W&&0<piy&&piy<jMAP_H;
}

bool jLocal2map(matrix<float> pnt,int& pix,int& piy) {
  pix=(int)(jMAP_X+pnt.data[1]*jGND2MAP);
  piy=(int)(jMAP_Y+pnt.data[0]*jGND2MAP);
  return 0<pix&&pix<jMAP_W&&0<piy&&piy<jMAP_H;
}
