// code by jph

#define             mLOGIC_CALIBRATION        1
#define             mLOGIC_SLOPE_RESPONSE     4
#define             mLOGIC_TURN_CONTRACT      8
#define             mLOGIC_LOAD_DISTRIB_V     16
#define             mLOGIC_LOAD_DISTRIB_S     32
                    
#define             mCALIB_PASSIVE            0
#define             mCALIB_ELEF_UP            1
#define             mCALIB_ELEF_DN            2
#define             mCALIB_ELEB_UP            3
#define             mCALIB_ELEB_DN            4
#define             mCALIB_IGNITE             5
                    
#define             mLED_GREEN                1
#define             mLED_WHITE                2
                    
#define             mMOBILE                   6
#define             mMOBILE_FRONT             0
#define             mMOBILE_LEFT              1     // left and right are probably mixed up
#define             mMOBILE_BACK              2
#define             mMOBILE_RIGHT             3
#define             mMOBILE_ELONG             4
#define             mMOBILE_SPIN              5

#define             mMOBILE_TRL               0.06f
#define             mMOBILE_ANG               0.20f
                    
#define             mORION_FILE               "joyride\\classes\\orion.bin"
#define             mORION_EXIT               256

#define             mMOBILE_RADIUS            (sqrt(mSIZE0*mSIZE0+mSIZE1*mSIZE1)+0.10f)   // for spinning?
                    
matrix<float>       mSetSpeed(3,1);           // speed set by the planner
matrix<float>       mSetJoint(2,1);           // speed set by the planner

#define             mBUFFER                   32
unsigned char       mBuffer[mBUFFER];
unsigned char       mBufferOld[mBUFFER];
unsigned int        mLogic=0;
unsigned int        mCalib=0;
unsigned int        mLed=0;
matrix<float>       mMobile[mMOBILE];         // collection of samples to check for solid walls
matrix<float>       mMobileMap[mMOBILE];      // collection of samples to check for solid walls
matrix<float>       mMobileFrame;             // collection of samples to check for solid walls
matrix<int>         mMobility(mMOBILE,1);
matrix<int>         mJbotHaus(mMOBILE,1);     // 0 when j2b2 is in the way of direction, 1 otherwise
matrix<float>       mMouse(3,1);

linked<jMoviton*>   mMarks;

#define             mSIZE0                    0.32f       // exact
#define             mSIZE1                    0.571709f   // 1.03 measured sqrt(0.413*0.413-0.145*0.145)+0.125+0.06f  teaser margin
#define             mSIZE1N                   0.52f       // exact in the back 52 cm
#define             mSIZE2                    0.30f
#define             mTEASER_OFFSET            0.38f
#define             mTEASER_RADIUS            0.105f
#define             mTEASER_FITTOL            0.025f

#define             mTERRAIN                  5760000     // a lot of memory
#define             mROUTING_QUALITY          200
#define             mROUTING_MARGIN           120


#define             mTARGETS_FAILURE          0
#define             mTARGETS_DOINGIT          1
#define             mTARGETS_REACHED          2
                    
#define             mSPEED0_STD               2           // forward
#define             mSPEED1_STD               2           // turning
#define             mSPEED0_JOY               2.5f
#define             mSPEED1_JOY               2.5f
                    
#define             mJOINT_ELN                1.0f

matrix<float>       mOfs(3,1);                // point of teaser in m coordinates
matrix<float>       mPos(3,3,"eye");          // map coordinates (only valid when mMover)
matrix<float>       mInv(3,3,"eye");          // map coordinates (only valid when mMover)
matrix<float>       mTarget;                  // 3x3 atlas/globalst coordinates
jPlanon             mDust;                    // plan for j2b2 to follow mhk
jMoviton*           mMover=0;
matrix<float>       mStardust(3,4);           // point in the rear of marsokhod
matrix<float>       mAurora(3,228);           // exact, points for j2b2 to come behind mhk, used in joker_aurora
matrix<float>       mWiggle;                  // contains headings for joker_wiggle
                    
#define             mJOKER                4
#define             mJOKER_BACKUP         0
#define             mJOKER_AURORA         1
#define             mJOKER_WIGGLE         2
#define             mJOKER_TINYWIGGLE     3
                    
#define             mJOKER_BACKUP_        1
#define             mJOKER_AURORA_        2
#define             mJOKER_WIGGLE_        4
#define             mJOKER_TINYWIGGLE_    8

#define             mJOKER_RADIUS         0.5f
                    
int                 mJoker=mJOKER;            // any number mJOKER_XYZ or mJOKER for no joker
int                 mJokerReg=0;              // zero when (no) joker is played right now
matrix<float>       mJokerPos[mJOKER];        // 3x3 but only aff component is used for now

#define             mDENSITY_OFFSET       0.32f      // why here? :-( this is sooo ugly
  


matrix<float> mMobileBuild(void) {
  jDEBUG("mMobileBuild")
  matrix<float> mob(3,2000);
  int c1,c2;
  mob.numel=0;
  int top0=(int)( mSIZE0 *100);
  int bot0=(int)(-mSIZE0 *100);
  int top1=(int)( mSIZE1 *100);
  int bot1=(int)(-mSIZE1N*100);
  for (c1=bot1;c1<top1;c1+=3) { // every 3 cm
    mob.data[mob.numel++]=0.01f*top0;
    mob.data[mob.numel++]=0.01f*c1;
    mob.data[mob.numel++]=1;
    mob.data[mob.numel++]=0.01f*bot0;
    mob.data[mob.numel++]=0.01f*c1;
    mob.data[mob.numel++]=1;
    
    mob.data[mob.numel++]=0.01f*top0-0.03f;
    mob.data[mob.numel++]=0.01f*c1;
    mob.data[mob.numel++]=1;
    mob.data[mob.numel++]=0.01f*bot0+0.03f;
    mob.data[mob.numel++]=0.01f*c1;
    mob.data[mob.numel++]=1;
  }
  for (c1=1;c1<top0-1;c1+=3) { // ensure symmetry
    mob.data[mob.numel++]=+0.01f*c1;
    mob.data[mob.numel++]= 0.01f*top1;
    mob.data[mob.numel++]= 1;
    mob.data[mob.numel++]=+0.01f*c1;
    mob.data[mob.numel++]= 0.01f*bot1;
    mob.data[mob.numel++]= 1;
    
    mob.data[mob.numel++]=-0.01f*c1;
    mob.data[mob.numel++]= 0.01f*top1;
    mob.data[mob.numel++]= 1;
    mob.data[mob.numel++]=-0.01f*c1;
    mob.data[mob.numel++]= 0.01f*bot1;
    mob.data[mob.numel++]= 1;    
    
    mob.data[mob.numel++]= 0.01f*c1;
    mob.data[mob.numel++]= 0.01f*top1-0.03f;
    mob.data[mob.numel++]= 1;
    mob.data[mob.numel++]= 0.01f*c1;
    mob.data[mob.numel++]= 0.01f*bot1+0.03f;
    mob.data[mob.numel++]= 1;
    
    mob.data[mob.numel++]=-0.01f*c1;
    mob.data[mob.numel++]= 0.01f*top1-0.03f;
    mob.data[mob.numel++]= 1;
    mob.data[mob.numel++]=-0.01f*c1;
    mob.data[mob.numel++]= 0.01f*bot1+0.03f;
    mob.data[mob.numel++]= 1;
  }
  mob.size[1]=mob.numel/3;
  //sprintf(jChar,"mMobileBuild %d",mob.size[1]);
  //jDeclared.append(new std::string(jChar));
  return mob;
}

void mRoutingInit(void);

void mInit(void) {
  jDEBUG("mInit")
  int c1,c2;
  bool flg;
 	FILE *fid; //format: ndims,size[0:ndims-1],data
  fid=fopen(mORION_FILE,"wb");
  fclose(fid);
  mOfs.data[0]=0;
  mOfs.data[1]=mTEASER_OFFSET;
  mOfs.data[2]=1;
  mMobileFrame=mMobileBuild();
  for (c1=0;c1<mMOBILE;c1++)
    mMobileMap[c1]=matrix<float>(3,3,"eye");  
  
  // BEGIN: build collision structures  

  mMobileMap[mMOBILE_FRONT].data[7]= mMOBILE_TRL;
  mMobileMap[mMOBILE_LEFT ].data[0]= cos(mMOBILE_ANG);
  mMobileMap[mMOBILE_LEFT ].data[1]=-sin(mMOBILE_ANG);
  mMobileMap[mMOBILE_LEFT ].data[3]= sin(mMOBILE_ANG);
  mMobileMap[mMOBILE_LEFT ].data[4]= cos(mMOBILE_ANG);
  mMobileMap[mMOBILE_BACK ]=mMobileMap[mMOBILE_FRONT].solve(matrix<float>(3,3,"eye"));
  mMobileMap[mMOBILE_RIGHT]=mMobileMap[mMOBILE_LEFT ].solve(matrix<float>(3,3,"eye"));
  matrix<float> smp;
  for (c1=0;c1<4;c1++) {
    smp=mMobileMap[c1]*mMobileFrame;
    smp.numel=0;
    for (c2=0;c2<mMobileFrame.numel;c2+=3)
      if (mSIZE0<fabs(smp.data[c2+0])||mSIZE1<smp.data[c2+1]||smp.data[c2+1]<-mSIZE1N) {
        smp.data[smp.numel+0]=smp.data[c2+0];
        smp.data[smp.numel+1]=smp.data[c2+1];
        smp.numel+=3;
      }    
    smp.size[1]=smp.numel/3;
    mMobile[c1]=smp;
  }
    
  // END: build collision structures
  jDEBUG("mInit")
  int len;
  float ofs;
  ofs=0.05f;
  mMobile[mMOBILE_ELONG]=matrix<float>(3,50); // 50 is exact
  mMobile[mMOBILE_ELONG].numel=0;

  // BEGIN: elong field
  for (c1=-9;c1<=9;c1+=2) 
    for (c2=1;c2<6;c2++) {
      mMobile[mMOBILE_ELONG].data[mMobile[mMOBILE_ELONG].numel++]= c1*ofs;
      mMobile[mMOBILE_ELONG].data[mMobile[mMOBILE_ELONG].numel++]=-mSIZE1-c2*ofs;
      mMobile[mMOBILE_ELONG].data[mMobile[mMOBILE_ELONG].numel++]= 1;
    }
  // END: elong field
  jDEBUG("spin")
  // BEGIN: spin field
  mMobile[mMOBILE_SPIN]=matrix<float>(3,262); // exact!
  mMobile[mMOBILE_SPIN].numel=0;
  ofs=0.075f;
  matrix<float> pnt(2,1);
  for (c1=-20;c1<=20;c1++)
    for (c2=-20;c2<=20;c2++) {
      pnt.data[0]=c1*ofs;
      pnt.data[1]=c2*ofs;
      if (pnt.norm(2)<mMOBILE_RADIUS&&
         (pnt.data[0]<-mSIZE0||mSIZE0<pnt.data[0]||pnt.data[1]<-mSIZE1N||mSIZE1<pnt.data[1])) {
        mMobile[mMOBILE_SPIN].data[mMobile[mMOBILE_SPIN].numel++]= pnt.data[0];
        mMobile[mMOBILE_SPIN].data[mMobile[mMOBILE_SPIN].numel++]= pnt.data[1];
        mMobile[mMOBILE_SPIN].data[mMobile[mMOBILE_SPIN].numel++]= 1;
      }
    }
  for (c1=0;c1<628;c1+=10) {
    mMobile[mMOBILE_SPIN].data[mMobile[mMOBILE_SPIN].numel++]=mMOBILE_RADIUS*cos(c1*0.01f);
    mMobile[mMOBILE_SPIN].data[mMobile[mMOBILE_SPIN].numel++]=mMOBILE_RADIUS*sin(c1*0.01f);
    mMobile[mMOBILE_SPIN].data[mMobile[mMOBILE_SPIN].numel++]= 1;
  }
  // END: spin field
  for (c1=0;c1<mMOBILE;c1++)
    mMobile[c1].size[1]=mMobile[c1].numel/3;
  jDEBUG("star")
  // BEGIN: stardust
  mStardust.data[0]=       +0.10f; mStardust.data[ 1]=-mSIZE1N-0.01f; mStardust.data[ 2]=1;
  mStardust.data[3]=       -0.15f; mStardust.data[ 4]=-mSIZE1N-0.01f; mStardust.data[ 5]=1;
  mStardust.data[6]=+mSIZE0+0.05f; mStardust.data[ 7]=-mSIZE1N-0.01f; mStardust.data[ 8]=1;
  mStardust.data[9]=-mSIZE0-0.15f; mStardust.data[10]=-mSIZE1N-0.01f; mStardust.data[11]=1;
  // END: stardust
  
  mAurora.numel=0;
  int bot0=(int)((mSIZE0 +0.32f+0.05f)*100);
  int top0=(int)((mSIZE0 +0.32f+0.40f)*100);
  int bot1=(int)((mSIZE1N+0.32f+0.05f)*100);
  int top1=(int)((mSIZE1N+0.32f+0.40f)*100);
  for (c1=0;c1<top1;c1+=8)
    for (c2=-top0;c2<=top0;c2+=8) 
      if (bot1<c1||bot0<fabs(c2)) {
        mAurora.data[mAurora.numel++]= c2*0.01f;
        mAurora.data[mAurora.numel++]=-c1*0.01f;
        mAurora.data[mAurora.numel++]= 1;
      }    
  mAurora.size[1]=mAurora.numel/3;
  
  mMover=new jMoviton;
  mMover->id=jMOVITON_ID_MARSOKHOD;
  mMover->stamp =jTic[jTOC_LAST_SENSORS];
  mMover->visual=jTic[jTOC_LAST_SENSORS];
  mMover->pos=matrix<float>(3,3,"eye");
  mMover->ini=matrix<float>(3,1);               // when initialize: ini contains point of teaser
  mMover->ini.data[0]=mMover->pos.data[6];     
  mMover->ini.data[1]=mMover->pos.data[7];
  mMover->ini.data[2]=1;
  mMover->add=matrix<float>(3,1);
  mMover->active=1;
  mMover->contour=new matrix<float>(3,4);                      // pointer to contour matrix (in local coordinates)
  mMover->contour->data[0]=+mSIZE0; mMover->contour->data[ 1]=+mSIZE1;  mMover->contour->data[ 2]=1;
  mMover->contour->data[3]=-mSIZE0; mMover->contour->data[ 4]=+mSIZE1;  mMover->contour->data[ 5]=1;
  mMover->contour->data[6]=-mSIZE0; mMover->contour->data[ 7]=-mSIZE1N; mMover->contour->data[ 8]=1;
  mMover->contour->data[9]=+mSIZE0; mMover->contour->data[10]=-mSIZE1N; mMover->contour->data[11]=1;  
  matrix<float> tmp("sav\\mpos.mat");
  if (tmp.data)
    mMover->pos=tmp;
  mMover->track.prepend(mMover->pos);
  mMover->rested=mMover->pos;  
  mTarget=mMover->pos;
  
  jTog[jTOG_POWER_SAVE]=true;
  for (c1=0;c1<mJOKER;c1++)
    mJokerPos[c1]=matrix<float>(3,3,"eye");
  mRoutingInit();
}

void mProcess(SDL_Event &mySDL_Event) {
  int c1,c2;
  if (mySDL_Event.type==SDL_KEYDOWN) {
    switch (mySDL_Event.key.keysym.sym) {
      case SDLK_F5:   mJoker=mJOKER_BACKUP;             break;
      case SDLK_F6:   mJoker=mJOKER_AURORA;             break;
      case SDLK_F7:   mJoker=mJOKER_WIGGLE;             break;
      case SDLK_F8:   mJoker=mJOKER_TINYWIGGLE;         break;
      case SDLK_KP8:  mSetSpeed.data[0]=+mSPEED0_STD;   break;
      case SDLK_KP2:  mSetSpeed.data[0]=-mSPEED0_STD;   break;
      case SDLK_KP6:  mSetSpeed.data[1]=+mSPEED1_STD;   break;
      case SDLK_KP4:  mSetSpeed.data[1]=-mSPEED1_STD;   break;
  	}
  }
  if (mySDL_Event.type==SDL_KEYUP) {
    switch (mySDL_Event.key.keysym.sym) {
      case SDLK_KP8:  mSetSpeed.data[0]=0;              break;
      case SDLK_KP2:  mSetSpeed.data[0]=0;              break;
      case SDLK_KP6:  mSetSpeed.data[1]=0;              break;
      case SDLK_KP4:  mSetSpeed.data[1]=0;              break;
    }
  }
}

// protected
void mDownlink(int adr,int dat) {
  mBuffer[adr+3]=(unsigned char)((dat&0xff)>>0);
  mBuffer[adr+2]=(unsigned char)((dat&0xff00)>>8);  
  mBuffer[adr+1]=(unsigned char)((dat&0xff0000)>>16);    
  mBuffer[adr+0]=(unsigned char)((dat&0xff000000)>>24);
}

void mControl(void) {
  int c1;
  int led=mLED_GREEN;
  for (c1=mMOBILE_FRONT;c1<=mMOBILE_RIGHT;c1++)
    led&=mMobility.data[c1]; // green led if free: front, left, right
  mLed|=led;
  jTog[jTOG_JBOT_HAUS]=(0<mSetSpeed.data[0]  &&!mJbotHaus.data[mMOBILE_FRONT])||  // mhk hits j2b2 with front
                       (0<mSetSpeed.data[1]  &&!mJbotHaus.data[mMOBILE_LEFT ])||  // etc.
                       (  mSetSpeed.data[1]<0&&!mJbotHaus.data[mMOBILE_RIGHT]);   // etc.
  mSetSpeed.data[0]*=mMobility.data[mMOBILE_FRONT]||mSetSpeed.data[0]<0;
  mSetSpeed.data[0]*=mMobility.data[mMOBILE_BACK ]||mSetSpeed.data[0]>0;
  mSetSpeed.data[1]*=mMobility.data[mMOBILE_LEFT ]||mSetSpeed.data[1]<0;          // left free or mhk goes right
  mSetSpeed.data[1]*=mMobility.data[mMOBILE_RIGHT]||mSetSpeed.data[1]>0;
  mSetSpeed*=mMover->active*(mMover->visual==jTic[jTOC_LAST_SENSORS]);
  if (jTog[jTOG_JOYSTICK]) {
    mLogic=jButton.data[3];
    mCalib=mCALIB_ELEF_UP*jButton.data[5]+mCALIB_ELEF_DN*jButton.data[7]
          +mCALIB_ELEB_UP*jButton.data[4]+mCALIB_ELEB_DN*jButton.data[6]
          +mCALIB_IGNITE *jButton.data[2];
    mSetSpeed.data[0]=mSPEED0_JOY*jAxis.data[0];
    mSetSpeed.data[1]=mSPEED1_JOY*jAxis.data[1];
    mSetJoint.data[0]=mJOINT_ELN*(jButton.data[7]-jButton.data[5]);
    mSetJoint.data[1]=mJOINT_ELN*(jButton.data[4]-jButton.data[6]);
  } else
    if (jTog[jTOG_MBOT_IGNITED]) {
      mSetJoint.data[0]= mJOINT_ELN; // bring up cylinder
      mSetJoint.data[1]=-mJOINT_ELN;
      // something blocks in the rear or wiggle is going on or robot is rendered as pure obstacle
      if (!mMobility.data[mMOBILE_ELONG]||
          (mJokerReg&&(mJoker==mJOKER_WIGGLE||mJoker==mJOKER_AURORA))||
           jTog[jTOG_POWER_SAVE]||           
          !mMover->active)
        jTic[jTOC_NEXT_ELONGATE]=jTic[jTOC_LAST_SENSORS]+5000;
      if (jTic[jTOC_NEXT_ELONGATE]<jTic[jTOC_LAST_SENSORS])
        mSetJoint.data[1]= mJOINT_ELN;
    }
  if (jTic[jTOC_NEXT_SHUTDOWN]<jTic[jTOC_LAST_SENSORS]) {
    mSetJoint.data[0]= mJOINT_ELN;
    mSetJoint.data[1]=-mJOINT_ELN;
  }
  jTog[jTOG_MBOT_IGNITED]|=0.1f<mSetSpeed.norm(2);
  mSetSpeed*=jTic[jTOC_LAST_SENSORS]<jTic[jTOC_NEXT_SHUTDOWN];
  if (0<mSetSpeed.norm(2))
    mMover->stamp=jTic[jTOC_LAST_SENSORS];
  // BEGIN: downlink if some things have changed
  mDownlink( 0,mLogic); // logic
  mDownlink( 4,mCalib); // calib
  mDownlink( 8,mLed);   // led  
  mDownlink(12,(int)(mSetSpeed.data[0]*1000)); // push
  mDownlink(16,(int)(mSetSpeed.data[1]*1000)); // turn
  mDownlink(20,(int)(mSetSpeed.data[2]*1000)); // dig
  mDownlink(24,(int)(mSetJoint.data[0]*1000)); // 
  mDownlink(28,(int)(mSetJoint.data[1]*1000)); // 
  bool flg=true;
  for (c1=0;c1<mBUFFER;c1++)
    flg&=(mBuffer[c1]==mBufferOld[c1]);
  if (!flg) {
    memcpy(mBufferOld,mBuffer,mBUFFER);
    FILE *fid;
    fid=fopen(mORION_FILE,"ab+");  
    fwrite(&mBuffer,1,mBUFFER,fid);
    fclose(fid);
  }
  // END: downlink if some things have changed
  // BEGIN: reset values  
  mLed=0;
  // END: reset values  
}

// this function outputs into folder SAV
void mShutdown(void) {
  mLogic=mORION_EXIT;  
  mSetSpeed*=0;
  mSetJoint*=0;
  jTog[jTOG_JOYSTICK]=0;
  mControl();
  mMover->pos.store("sav\\mpos.mat");
}

