// code by jph

SDL_Surface*            mDensityDraw;                   // constructor and visualization of density function
                        
float                   mRouteDist[mTERRAIN];           // reserve space for routing
int                     mRoutePred[mTERRAIN];           // reserve space for routing
int                     mRouteMask[mTERRAIN];           // reserve space for routing

int                     mRouteDel[16];
int                     mRouteOfs[16][4];
float                   mRouteFac[16][4];
Uint32*                 mDensityDrawPixels;
int                     mRoutePixMin,mRoutePixMax,mRoutePiyMin,mRoutePiyMax;
int                     mRouteMsk[50];
int                     mRouteTok[ 8][50];
int                     mRouteFwd[16];

void mRoutingInit(void) {
  jDEBUG("mRoutingInit")
  int c1;
  mDensityDraw=SDL_CREATERGBSURFACE(jMAP_W,jMAP_H);
  float one=1.0f,rt2=sqrt(2.0),rt5=sqrt(5.0);    
  mRouteDel[ 0]=   1;                   mRouteFac[ 0][0]=one;
  mRouteDel[ 1]=  -jMAP_W+2;            mRouteFac[ 1][0]=rt5;
  mRouteDel[ 2]=  -jMAP_W+1;            mRouteFac[ 2][0]=rt2;
  mRouteDel[ 3]=-2*jMAP_W+1;            mRouteFac[ 3][0]=rt5;
  mRouteDel[ 4]=  -jMAP_W;              mRouteFac[ 4][0]=one;
  mRouteDel[ 5]=-2*jMAP_W-1;            mRouteFac[ 5][0]=rt5;
  mRouteDel[ 6]=  -jMAP_W-1;            mRouteFac[ 6][0]=rt2;
  mRouteDel[ 7]=  -jMAP_W-2;            mRouteFac[ 7][0]=rt5;
  mRouteDel[ 8]=  -1;                   mRouteFac[ 8][0]=one;
  mRouteDel[ 9]=  +jMAP_W-2;            mRouteFac[ 9][0]=rt5;
  mRouteDel[10]=  +jMAP_W-1;            mRouteFac[10][0]=rt2;
  mRouteDel[11]= 2*jMAP_W-1;            mRouteFac[11][0]=rt5;
  mRouteDel[12]=   jMAP_W;              mRouteFac[12][0]=one;
  mRouteDel[13]= 2*jMAP_W+1;            mRouteFac[13][0]=rt5;
  mRouteDel[14]=   jMAP_W+1;            mRouteFac[14][0]=rt2;
  mRouteDel[15]=   jMAP_W+2;            mRouteFac[15][0]=rt5;
  for (c1=0;c1<16;c1++) {
    mRouteOfs[c1][0]=-mRouteDel[c1]*16;
    mRouteOfs[c1][1]= mRouteDel[c1]*16; mRouteFac[c1][1]=2*mRouteFac[c1][0];
    mRouteOfs[c1][2]=(c1+ 1)&0xf;       mRouteFac[c1][2]=one;
    mRouteOfs[c1][3]=(c1+15)&0xf;       mRouteFac[c1][3]=one;
  }
  int piz,pin;
  float lam,nxt,wdt=21;
  for (piz=0;piz<8;piz++) {
    mRouteTok[piz][0]=0;
    lam=0;
    pin=0;
    nxt=3;
    while (lam<wdt) {
      pin+=mRouteDel[piz];
      lam+=mRouteFac[piz][0];
      if (nxt<lam) {
        mRouteTok[piz][0]++;
        mRouteTok[piz][mRouteTok[piz][0]]=pin;
        nxt=nxt+2.6;
      }
    }
    mRouteTok[piz][0]+=(mRouteTok[piz][mRouteTok[piz][0]]!=pin);
    mRouteTok[piz][mRouteTok[piz][0]]=pin;
    mRouteFwd[piz  ]= pin; // index for driving forward and backward
    mRouteFwd[piz+8]=-pin; // index for driving forward and backward
    lam=0;
    pin=0;
    nxt=3;
    while (lam<wdt) {
      pin-=mRouteDel[piz];
      lam+=mRouteFac[piz][0];
      if (nxt<lam) {
        mRouteTok[piz][0]++;
        mRouteTok[piz][mRouteTok[piz][0]]=pin;
        nxt=nxt+2.6;
      }
    }
    mRouteTok[piz][0]+=(mRouteTok[piz][mRouteTok[piz][0]]!=pin);
    mRouteTok[piz][mRouteTok[piz][0]]=pin;
  }
}

// floors it, so add one mod 16 to have window
int mRoutingPiz(matrix<float>& frm) {
  int ret;
  float ang=atan2(frm.data[1],frm.data[0])*jRAD2DEG;
  if (ang<0)
    ang+=360;
  ret=(int)((ang+11.25f)/360*16)&0xf;
  sprintf(jChar,"marsokhod %6.3f %d",ang,ret);
  jBulletin.append(new std::string(jChar));
  return ret;
}

// returns frame
matrix<float> mRoutingPiz(int pta) {
  int pix,piy;
  pix=(pta>>4)%jMAP_W;
  piy=(pta>>4)/jMAP_W;
  float ang=(pta&0xf)/8.0f*jM_PI;
  matrix<float> com(3,3,"eye");
  com.data[0]=cos(ang);
  com.data[1]=sin(ang);
  com.data[3]=-com.data[1];
  com.data[4]=com.data[0];
  com.data[6]=(piy-jMAP_Y)*jMAP2GND;
  com.data[7]=(pix-jMAP_X)*jMAP2GND;
  return com;
}

int mDensity(int pii) {
  int c1,piz,pin,flg;
  int pix,piy;
  piz=pii&0x7;  
  pin=pii>>4;
  flg=mDensityDrawPixels[pin]; // faster than dividing the numbers!
  for (c1=1;c1<=mRouteTok[piz][0]&&flg;c1++)
    flg&=cDensity[pin+mRouteTok[piz][c1]];
  return flg;
}

int mDensityFwd(int pii) {
  int c1,piz,pin,flg;
  int pix,piy;
  piz=pii&0xf;
  pin=pii>>4;
  flg=mDensityDrawPixels[pin]; // faster than dividing the numbers!
  flg&=cDensity[pin+mRouteFwd[piz]];
  return flg;
}

// mRouting computes from robots position distances to all points in density considering also orientation
void mRouting(int pia) {
  jDEBUG("mRouting pia")
  int c1,piz,pii,cnt=0;
  float met;
  for (c1=0;c1<mTERRAIN;c1++)
    mRouteMask[c1]=0;
  int* lizt0=(int*)cTerrainStub->pixels;
  int  lizt0_cnt=0;
  int  lizt0_tok=0;
  int* lizt1=&lizt0[cTERRAIN>>1];
  int  lizt1_cnt=0;
  int  lizt1_tok=0;
  int* liztt;
  lizt0[lizt0_cnt++]=pia;
  mRouteDist[pia]=0;
  mRoutePred[pia]=pia;
  while (lizt0_tok<lizt0_cnt&&cnt<mROUTING_QUALITY) {
    cnt++;
    while (lizt0_tok<lizt0_cnt) {
      pia=lizt0[lizt0_tok++];
      piz=pia&0xf;
      pii=pia+mRouteOfs[piz][0];
      if (mDensityFwd(pii))                            // only visit explored terrain (metric =0 whereever unexplored)        
        if (mRouteDist[pia]+mRouteFac[piz][0]<mRouteDist[pii]) {
          mRouteDist[pii]=mRouteDist[pia]+mRouteFac[piz][0];
          mRoutePred[pii]=pia;
          if (mRouteMask[pii]<cnt) {                // prevents to have the same vertex added in the same iteration step
            mRouteMask[pii]=cnt;
            lizt1[lizt1_cnt++]=pii;
          }
        }
      pii=pia-piz+mRouteOfs[piz][2];
      if (mDensity(pii))                            // only visit explored terrain (metric =0 whereever unexplored)        
        if (mRouteDist[pia]+mRouteFac[piz][2]<mRouteDist[pii]) {
          mRouteDist[pii]=mRouteDist[pia]+mRouteFac[piz][2];
          mRoutePred[pii]=pia;
          if (mRouteMask[pii]<cnt) {                // prevents to have the same vertex added in the same iteration step
            mRouteMask[pii]=cnt;
            lizt1[lizt1_cnt++]=pii;
          }
        }
      pii=pia-piz+mRouteOfs[piz][3];
      if (mDensity(pii))                            // only visit explored terrain (metric =0 whereever unexplored)        
        if (mRouteDist[pia]+mRouteFac[piz][3]<mRouteDist[pii]) {
          mRouteDist[pii]=mRouteDist[pia]+mRouteFac[piz][3];
          mRoutePred[pii]=pia;
          if (mRouteMask[pii]<cnt) {                // prevents to have the same vertex added in the same iteration step
            mRouteMask[pii]=cnt;
            lizt1[lizt1_cnt++]=pii;
          }
        }
    }
    lizt0_tok=0;
    lizt0_cnt=lizt1_cnt;
    lizt1_cnt=0;
    liztt=lizt0;
    lizt0=lizt1;
    lizt1=liztt;
  }
}

void mRoutingDraw(void) {
  jDEBUG("mRoutingDraw")
  int c1,c2;
  int pia;
  float sum;
  SDL_FillRect(mDensityDraw,NULL,0);
  SDL_LockSurface(mDensityDraw);        
  Uint32* myDraw=(Uint32*)(mDensityDraw->pixels);
  for (c1=0;c1<cTERRAIN;c1++) {
    if (cTerrain[c1]==cTERRAIN_FREE) {
      pia=c1<<4;
      sum=0;
      for (c2=0;c2<16;c2++)
        sum+=mRouteDist[pia+c2]*(mRouteDist[pia+c2]<cTERRAIN);
      if (0<sum) {          
        c2=(int)sum;
        c2>>=4;
        c2&=0x1f;
        myDraw[c1]=0xff007f00|(c2<<18);
      }
    }
  }
  SDL_UnlockSurface(mDensityDraw);  
}


// density map computation
// main routing
void mRouting(void) {
  jDEBUG("mRouting")
  int c1,c2;
  int pix,piy;
  int pjx,pjy;
  if (true) {    
    if (jAtlas2map(mTarget.aff_pnt(2),pix,piy)&&jAtlas2map(mMover->pos.aff_pnt(2),pjx,pjy)) {
      jTog[jTOG_HEAVY_DUTY]=true;    
      jTic[jTOC_TIME_ROUTING2]=jCLOCK_FUNC;
      for (c1=0;c1<mTERRAIN;c1++) {
        mRouteDist[c1]=cTERRAIN;
        mRoutePred[c1]=0;
      }
      mMover->active=1;      
      cDensing(mDENSITY_OFFSET,mDENSITY_OFFSET);
      mRoutePixMin=MAX(0,MIN(pix,pjx)-mROUTING_MARGIN);
      mRoutePiyMin=MAX(0,MIN(piy,pjy)-mROUTING_MARGIN);
      mRoutePixMax=MIN(jMAP_W,MAX(pix,pjx)+mROUTING_MARGIN);
      mRoutePiyMax=MIN(jMAP_W,MAX(piy,pjy)+mROUTING_MARGIN);      
      SDL_FillRect(mDensityDraw,NULL,0);
      SDL_Rect mySDL_Rect;
      mySDL_Rect.x=mRoutePixMin;
      mySDL_Rect.y=mRoutePiyMin;
      mySDL_Rect.w=mRoutePixMax-mRoutePixMin;
      mySDL_Rect.h=mRoutePiyMax-mRoutePiyMin;      
      SDL_FillRect(mDensityDraw,&mySDL_Rect,0xffffffff);
      SDL_LockSurface(mDensityDraw);
      mDensityDrawPixels=(Uint32*)(mDensityDraw->pixels);
      mRouting((piy*jMAP_W+pix<<4)+mRoutingPiz(mTarget));                        // some crazy shit!
      SDL_UnlockSurface(mDensityDraw);
    } else 
      jDeclared.prepend(new std::string("mTarget out of bounds"));    
    // END: visualize distance profile produced by routing
    jTic[jTOC_TIME_ROUTING2]=jCLOCK_FUNC-jTic[jTOC_TIME_ROUTING2];
    mRoutingDraw();
  }
}

void pPlaces(linked<jMoviton*>& plc,matrix<float> cmv,bool& jmd,float psp);

void mMarking(void) {
  jDEBUG("mPlanning")
  mMover->idea.planned=false;
  mMover->idea.dist=0.0f;    
  mMover->idea.list.clear();
  mMover->idea.compass=matrix<float>(3,1);
  jMoviton* tok;
  while (mMarks.token(tok)) {
    delete tok;
    mMarks.remove();
  }
  int c1,c2;
  int pix,piy,piz,pjz,pin,pjn,pta,ptm;
  bool flg=false;
  matrix<float> frm,trl(3,1),ofs;
  pjz=mRoutingPiz(mMover->pos);
  trl.data[2]=1;
  float cmp=cTERRAIN;
  if (jAtlas2map(mMover->pos.aff_pnt(2),pix,piy)) {
    pta=((piy*jMAP_W+pix)<<4)+pjz;
    if (mRouteDist[pta]<cmp&&mRoutePred[pta]) {
      ofs=trl;
      ptm=pta;
      cmp=mRouteDist[pta];
      flg|=true; 
    }
  }
  if (flg) {
    pta=ptm;
    pjn=pta>>4;
    flg=false;
    mMover->idea.planned=true;
    mMover->idea.dist=mRouteDist[pta]*jMAP2GND;
    while (mRoutePred[pta]&&pta!=mRoutePred[pta]) {       // hop from predecessor to next predecessor      
      pin=pta>>4;
      pix=pin%jMAP_W;
      piy=pin/jMAP_W;
      piz=pta&0xf;
      pixelRGBA(cMap,pix,piy,0x00,0x00,0x00,0xff);        // TODO REMOVE
      mMover->idea.list.append(pin);                         // until predecessor is NULL          
      if (pjz!=piz&&flg) {
        pjz=piz;
        pjn=pin;
        pPlaces(mMarks,mRoutingPiz(pta).aff_pnt(2),flg,0.04f);
        flg=false;
      }
      flg=pjn!=pin;
      pta=mRoutePred[pta];
      c1++;
    }
    pPlaces(mMarks,mRoutingPiz(pta).aff_pnt(2),flg,0.04f);    // append final target
    jAtlas2map(mMover->pos.aff_pnt(2),pix,piy);
    pixelRGBA(cMap,pix,piy,0xff,0x00,0x00,0xff);        // TODO REMOVE    
    jDeclared.append(new std::string("path planning successful"));
  }
}

void mMarkingDraw(void) {
  jDEBUG("mMarkingDraw")
  int c1;
  int pix,piy;
  jMoviton* tok;
  jDrawPlan(mMover->idea);
  if (mMover->idea.planned) {
    c1=0;
    while (mMarks.token(tok)) {
      jAtlas2map(tok->pos.aff_pnt(2),pix,piy);
      ellipseRGBA(cMap,pix,piy,1,1,0xff,0xff,0xff,0xff);        // TODO REMOVE        
      sprintf(jChar,"%d %6.3f %6.3f",c1++,tok->pos.data[6],tok->pos.data[7]);
      jBulletin.append(new std::string(jChar));
    }
  }  
}

void mTargets(int& res) {  
  mSetSpeed*=0;
  matrix<float> loc=(mInv*cTarget).aff_vec(0);    // THIS LINE SKREWS IT UP!  bug in compiler of dev-cpp involving templates
  float dst=loc.norm(2);
  float ang=atan2(-loc.data[0],loc.data[1]);      // angle with respect to front, left is positive  
  float bnd;
  if (jTic[jTOC_LAST_SENSORS]<jTic[jTOC_STOP_MBOT_TARGET]&&jTic[jTOC_LAST_SENSORS]<jTic[jTOC_STOP_MBOT_TOLERATE]) {
    if (dst<0.2f&&fabs(ang)<1)
      jTic[jTOC_STOP_MBOT_TARGET]=MIN(jTic[jTOC_LAST_SENSORS]+12000,jTic[jTOC_STOP_MBOT_TARGET]);  
    if (0.03f<dst) {
      mSetSpeed.data[1]=MIN(MAX(-mSPEED1_STD,-5*ang),mSPEED1_STD);
      mSetSpeed.data[1]*=mMobility.data[mMOBILE_RIGHT]||mSetSpeed.data[1]>0;
      mSetSpeed.data[1]*=mMobility.data[mMOBILE_LEFT ]||mSetSpeed.data[1]<0;
      bnd=MAX(0,mSPEED0_STD-(1.5+(dst<0.2f))*fabs(mSetSpeed.data[1]));
      sprintf(jChar,"target ang %6.3f dist %6.3f bnd %6.3f",ang,dst,bnd);
      jBulletin.append(new std::string(jChar));
      mSetSpeed.data[0]=MIN(MAX(-bnd,4.5f*loc.data[1]),bnd); // tuned
      mSetSpeed.data[0]*=mMobility.data[mMOBILE_FRONT];
      if (mSetSpeed.norm(2))
        jTic[jTOC_STOP_MBOT_TOLERATE]=jTic[jTOC_LAST_SENSORS]+2000;
      res=mTARGETS_DOINGIT;
    } else
      res=mTARGETS_REACHED;
  } else {    
    if (dst<0.15f) {
      jDeclared.prepend(new std::string("timeout in bounds"));
      res=mTARGETS_REACHED;
    } else {
      jDeclared.prepend(new std::string("timeout out of bounds"));
      res=mTARGETS_FAILURE;
    }
  }
}

bool mTouring(void) {
  int res;
  jMoviton* tok;
  if (mMarks.token(tok)) {
    cTarget=(pInv*tok->pos).aff_pnt(2);
    mTargets(res);
    switch (res) {
      case mTARGETS_FAILURE:
        jDeclared.prepend(new std::string("targets failure"));        
        mMarks.reset();
        cReset(mMarks);
        return false;
        break;
      case mTARGETS_REACHED:
        jDeclared.prepend(new std::string("target reached"));
        mMarks.remove();
        jTic[jTOC_STOP_MBOT_TARGET]=jTic[jTOC_LAST_SENSORS]+60000;
        jTic[jTOC_STOP_MBOT_TOLERATE]=jTic[jTOC_LAST_SENSORS]+2000; 
        break;
    }
  } else { // last mark has been reached, now align to mTarget
    mWiggle=matrix<float>(3,1);
    mWiggle.data[0]=mTarget.data[3];
    mWiggle.data[1]=mTarget.data[4];
    return mWiggles();   // marks list is empty no reset necessary!    
  }
  mMarks.reset();
  return true;
}
