// code by jph
// operator control of Marsokhod with the
// Logitech Dual Action joystick

import com.centralnexus.input.*;
import java.io.*;

public class AstronautLogitechDA {
  
  static public void main(String[] args) {
    int c1;
    double tmp;
    Joyride.IP="192.168.1.187"; // when running from laptop
    if (0<args.length)
      Joyride.IP=args[0];
    try {
      Joystick myJoystick=Joystick.createInstance();
      myJoystick.setDeadZone(0.20);   // unfortunately the joystick is quite worn out
      Control myControl=new Control(1,1.0,.1,.1);
      
      Joyride.open();     // open connection to joyride (the server on Marsokhod)
      Marsokhod.init();   // create instance of Marsokhod that will be updated by messages from joyride      
      Status.init();      // gui to display status of marsokhod
      Config.init();      // gui to change configuration of marsokhod
        
      while (!myJoystick.isButtonDown(Joystick.BUTTON10)) {
        myJoystick.poll();
        myControl.vd=0.2;
        tmp=Math.max(Math.abs(myJoystick.getY()),Math.abs(myJoystick.getX()));
        if (0<tmp)
          myControl.vd=myControl.vn;
        if (0.99<tmp)
          myControl.vd=1;
        myControl.V();
        
        Marsokhod.calib=Marsokhod.CALIB_PASSIVE;
        Marsokhod.led  =0;
        Rolk.boost=-0.5*Marsokhod.VEL*myJoystick.getR(); // forward
        Marsokhod.myControl[Marsokhod.PUSH].vd=-Marsokhod.VEL*myControl.vn*myJoystick.getY(); // forward
        Marsokhod.myControl[Marsokhod.TURN].vd= Marsokhod.VEL*myControl.vn*myJoystick.getX(); // turning
        Marsokhod.myControl[Marsokhod.DIGG].vd= Marsokhod.VEL*myControl.vn*myJoystick.getZ(); // digging
        Marsokhod.myControl[Marsokhod.ELEF].vd= 0;
        Marsokhod.myControl[Marsokhod.ELEB].vd= 0;
        
        if (myJoystick.isButtonDown(Joystick.BUTTON6)) { // elongate front joint
          Marsokhod.myControl[Marsokhod.ELEF].vd-=Marsokhod.VEL*0.3;        
          Marsokhod.calib=Marsokhod.CALIB_ELEF_UP;
        }
        if (myJoystick.isButtonDown(Joystick.BUTTON8)) { // contract front joint
          Marsokhod.myControl[Marsokhod.ELEF].vd+=Marsokhod.VEL*0.3;
          Marsokhod.calib=Marsokhod.CALIB_ELEF_DN;
        }
        if (myJoystick.isButtonDown(Joystick.BUTTON5)) { // elongate front joint
          Marsokhod.myControl[Marsokhod.ELEB].vd+=Marsokhod.VEL*0.3;
          Marsokhod.calib=Marsokhod.CALIB_ELEB_UP;
        }
        if (myJoystick.isButtonDown(Joystick.BUTTON7)) { // contract front joint
          Marsokhod.myControl[Marsokhod.ELEB].vd-=Marsokhod.VEL*0.3;
          Marsokhod.calib=Marsokhod.CALIB_ELEB_DN;
        }          
        if (myJoystick.isButtonDown(Joystick.BUTTON4)) {
          Marsokhod.logic=Marsokhod.LOGIC_CALIBRATION;
          if (myJoystick.isButtonDown(Joystick.BUTTON3))
            Marsokhod.calib=Marsokhod.CALIB_IGNITE;
        } else
          Marsokhod.logic&=~Marsokhod.LOGIC_CALIBRATION;            
        //if (myJoystick.isButtonDown(Joystick.BUTTON3))
        //  Marsokhod.logic|=Marsokhod.LOGIC_SLOPE_RESPONSE|Marsokhod.LOGIC_TURN_CONTRACT;
        if (0<=myJoystick.getPOV()) {
          Rolk.mode=(int)Math.round(myJoystick.getPOV()/90);
          Rolk.mode%=Marsokhod.myRolk.length;
        }
        Config.refresh();
        Joyride.downlink(); // contains sleep
        Status.refresh();
      }
      Joyride.close();
      
    } catch (Exception myException) {
      System.out.println(myException);      
    }    
    System.exit(0);
  }
  

}
