// code by jph

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

public class Config {
  static final int WIDTH=550;
  static final int HEIGHT=53;  
  static final String[] TTT={"","state of green led","state of white led","smart placement","slant response","turning contracts","load distribution"};
  static final String[] UPS={"1.0 V","1.5 V","2.0 V","2.5 V","3.0 V"};
  
  static JToggleButton[] myJToggleButton=new JToggleButton[10];
  static final int SMP=3;
  static final int SRP=4;
  static final int TCN=5;
  static final int LOD=6;
  static JComboBox myJComboBox;
  static JLabel myJLabel;
	
  static public void init() {
    int c1;
    JFrame myJFrame=new JFrame("Configuration");
    Container myContainer=new Container();
    myContainer.setLayout(new BorderLayout());
    
		JPanel myJPanel;
    myJPanel=new JPanel();
    myJPanel.setLayout(new BorderLayout());
		
    JToolBar myJToolBar;
    myJToolBar=new JToolBar();
    
    myJToolBar.add(myJToggleButton[Marsokhod.LED_GREEN]=new JToggleButton("",new ImageIcon("res/icon.bbg.gif")));
    myJToolBar.add(myJToggleButton[Marsokhod.LED_WHITE]=new JToggleButton("",new ImageIcon("res/icon.bby.gif")));
    myJToolBar.addSeparator();
    myJToolBar.add(myJComboBox=new JComboBox(UPS));
    myJComboBox.setToolTipText("threshold of voltage drop");
    myJComboBox.setSelectedIndex(1);
    myJToolBar.addSeparator();
    myJToolBar.add(myJToggleButton[SMP]=new JToggleButton("",new ImageIcon("res/icon.uta.gif")));    
    myJToolBar.add(myJToggleButton[SRP]=new JToggleButton("",new ImageIcon("res/icon.sco.gif")));    
    myJToolBar.add(myJToggleButton[TCN]=new JToggleButton("",new ImageIcon("res/icon.aba.gif")));
    myJToolBar.add(myJToggleButton[LOD]=new JToggleButton("",new ImageIcon("res/icon.fot.gif")));
    for (c1=SMP;c1<=LOD;c1++)
      myJToggleButton[c1].addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent myActionEvent) {          
          int c1;
          for (c1=SMP;c1<=LOD;c1++)
            if (myActionEvent.getSource()==myJToggleButton[c1])
              if (myJToggleButton[c1].isSelected())
                Marsokhod.logic|=1<<(c1-2);
              else
                Marsokhod.logic&=~(1<<(c1-2));
        }
      });
    for (c1=0;c1<=LOD;c1++)
      if (myJToggleButton[c1]!=null)
        myJToggleButton[c1].setToolTipText(TTT[c1]);
    myJToolBar.addSeparator();
    myJToolBar.addSeparator();
    myJToolBar.add(myJLabel=new JLabel(" "));
    myJToolBar.add(new JLabel("                                                                                                                                                                        "));
    
    myJToolBar.setFloatable(false);
    myJPanel.add(myJToolBar,"Center");        
    myContainer.add("North",myJPanel);		
    
    myJFrame.getContentPane().add(myContainer);
    myJFrame.setLocation(0,Status.HEIGHT);
    myJFrame.setSize(WIDTH,HEIGHT);
    myJFrame.setVisible(true);
  }
  
  static void refresh() {
    int c1;
    if (myJToggleButton[Marsokhod.LED_GREEN].isSelected())
      Marsokhod.led|=Marsokhod.LED_GREEN;
    if (myJToggleButton[Marsokhod.LED_WHITE].isSelected())
      Marsokhod.led|=Marsokhod.LED_WHITE;
    Marsokhod.UPS=Double.parseDouble(UPS[myJComboBox.getSelectedIndex()].substring(0,3));
    for (c1=SMP;c1<=LOD;c1++)
      myJToggleButton[c1].setSelected((Marsokhod.logic&(1<<(c1-2)))==(1<<(c1-2)));
    myJLabel.setText("rolk mode: "+Marsokhod.ROLK[Rolk.mode]);
  }  
}
