// code by jph

import java.io.*;
import java.util.*;

public class IntervalMap
{
  double[]  bot;
  double[]  top;
  int[]     val;
  int       idx;  
  int       err;
  int       size;
  
  Hashtable myHashtable;
  
  public IntervalMap(int size,int err) {
    bot=new double[size];
    top=new double[size];
    val=new int[size];
    idx=0;
    this.err=err;
    this.size=size;
    myHashtable=new Hashtable(size<<1);
  }
  
  /**
   * put() appends an intervals
   * intervals need to be added in ascending order
   **/
  public void put(double bot,double top,int val) {
    this.bot[idx]=bot;
    this.top[idx]=top;
    this.val[idx]=val;    
    ++idx;
  }
  
  public void put(int val,double mea) {
    myHashtable.put(new Integer(val),new Double(mea));
  }
  
  /**
   * get() implements binary search, assuming intervals are ordered!
   **/
  public int get(double key) {    
    int low=0;
    int hig=size-1;
    int mid;
    while (low<=hig) {
      mid=(low+hig)/2;
      if (key<bot[mid])
        hig=mid-1;
      else
        if (top[mid]<key)
          low=mid+1;
        else //{
          //System.out.println(key+" found in "+bot[mid]+"..."+top[mid]+" at "+mid+" with value "+val[mid]);
          return val[mid];
        //}
    }
    //System.out.println(key+" not found");
    return err;
  }
  
  public double get(int val) {
    Double myDouble;
    try {
      myDouble=(Double)myHashtable.get(new Integer(val));
      return myDouble.doubleValue();
    } catch (Exception myException) {
      //System.out.println(val+" not found");
      return 0;
    }
  }
  
  public void Doubles(String file) {
    String myString;
    String[] mySplit;    
    DataInputStream myDataInputStream;
    try {
      size=0;
      myDataInputStream=new DataInputStream(new FileInputStream(file));
      while (true) {
        myString=myDataInputStream.readLine();
        if (myString==null)
          break;
        mySplit=myString.split(" ");        
        put(Double.valueOf(mySplit[0]),
            Double.valueOf(mySplit[1]),
            Integer.valueOf(mySplit[2]));
        ++size;
      }
      myDataInputStream.close();      
    } catch (Exception myException) {
      System.out.println(myException);
    }
  }
  
  public void Integers(String file) {    
    String myString;
    String[] mySplit;    
    DataInputStream myDataInputStream;
    try {
      myDataInputStream=new DataInputStream(new FileInputStream(file));
      while (true) {
        myString=myDataInputStream.readLine();
        if (myString==null)
          break;
        mySplit=myString.split(" ");
        put(Integer.valueOf(mySplit[0]),
            Double.valueOf(mySplit[1]));
      }
      myDataInputStream.close();
    } catch (Exception myException) {
      System.out.println(myException);
    }
  }
    
}
