// code by jph

import java.io.*;
import java.net.*;

public class Joyride {
  static volatile String        IP="130.233.120.187"; // ???? use 192.168.1.187 for wireless
  static final int              TC=49402;
  static final int              HDR=0x12345678;
  
  static Socket                 mySocket;
  static DataInputStream        myDataInputStream;        // tcp
  static DataOutputStream       myDataOutputStream;       // tcp
  
  static ByteArrayOutputStream  nyByteArrayOutputStream=new ByteArrayOutputStream();  // preparation of message
  static DataOutputStream       nyDataOutputStream;
  
  static public void main(String[] args) {
    if (0<args.length)
      Mediator.IP=args[0];
    try {
      nyDataOutputStream=new DataOutputStream(nyByteArrayOutputStream);
      Mediator.open();
      Marsokhod.init();
      System.out.println("Note: calibrate joints for wheel walking");
      new Thread() {
        public void run() {
          int c1;
          try {
            while (true) {
              Marsokhod.run();
              if (mySocket!=null&&myDataInputStream!=null)
                uplink();
              if (Mediator.ido>5) 
                System.out.println(Mediator.ido);              
              sleep(23);
            }            
          } catch (Exception myException) {
            System.out.println(myException);
          }          
        }
      }.start();
      ServerSocket myServerSocket=new ServerSocket(TC);
      while (true) {
        mySocket=myServerSocket.accept();
        myDataInputStream=new DataInputStream(mySocket.getInputStream());
        myDataOutputStream=new DataOutputStream(mySocket.getOutputStream());
        System.out.println(mySocket);          
      }
    } catch (Exception myException) {
      System.out.println(myException);
      System.exit(0);
    }
  }
  
    
  static public void downlink() throws IOException { // ASTRONAUT <-> joyride
    int c1;
    nyByteArrayOutputStream.reset();
    nyDataOutputStream.writeInt(HDR);                                   // 4
    nyDataOutputStream.writeInt(Marsokhod.logic);                       // 4
    nyDataOutputStream.writeInt(Marsokhod.calib);                       // 4
    nyDataOutputStream.writeInt(Marsokhod.led);                         // 4
    nyDataOutputStream.writeFloat((float)Marsokhod.UPS);                // 4
    nyDataOutputStream.writeInt(Rolk.mode);                             // 4
    nyDataOutputStream.writeFloat((float)Rolk.boost);                   // 4                                                                        
    for (c1=Marsokhod.PUSH;c1<=Marsokhod.ELEB;c1++)
      nyDataOutputStream.writeFloat((float)Marsokhod.myControl[c1].vd); // 6*4      
    nyDataOutputStream.flush();
    byte[] myByte=nyByteArrayOutputStream.toByteArray();
    myDataOutputStream.write(myByte,0,myByte.length);
    myDataOutputStream.flush();
    while (0==myDataInputStream.available())
      try {
        Thread.sleep(2);
      } catch (Exception myException) {
        System.out.println(myException);
      }
    while (0<myDataInputStream.available()) {     // 212
      if (myDataInputStream.readInt()==HDR) {
        Control.clk=myDataInputStream.readDouble();
        Control.dlt=myDataInputStream.readFloat();
        for (c1=0;c1<8;c1++) {
          Marsokhod.pos[c1]=myDataInputStream.readFloat();
          Marsokhod.bcl[c1]=myDataInputStream.readFloat();
          Marsokhod.vel[c1]=myDataInputStream.readFloat();
          Marsokhod.lod[c1]=myDataInputStream.readFloat();
          Marsokhod.pwm[c1]=myDataInputStream.readInt();
  	    }
        Marsokhod.vcc   =myDataInputStream.readFloat();
        Marsokhod.VCC   =myDataInputStream.readFloat();
        Marsokhod.gyr   =myDataInputStream.readFloat();
        Marsokhod.grv[0]=myDataInputStream.readFloat();
        Marsokhod.grv[1]=myDataInputStream.readFloat();
        Marsokhod.grv[2]=myDataInputStream.readFloat();        
        Marsokhod.myControl[Marsokhod.PUSH].dd=myDataInputStream.readFloat();
        Marsokhod.myControl[Marsokhod.ELEF].ei=myDataInputStream.readFloat();
        Marsokhod.myControl[Marsokhod.ELEB].ei=myDataInputStream.readFloat();        
        Marsokhod.PWMvex();
      } else
        System.out.println("hdr!");
    }
  }
  
  static public synchronized void uplink() throws IOException { // JOYRIDE <-> astronaut
    int c1;
    boolean recv=false;
    while (0<myDataInputStream.available()) {
      if (myDataInputStream.readInt()==HDR) {
        Marsokhod.logic=myDataInputStream.readInt();
        Marsokhod.calib=myDataInputStream.readInt();
        Marsokhod.led  =myDataInputStream.readInt();
        Marsokhod.UPS  =myDataInputStream.readFloat();
        Rolk.mode      =myDataInputStream.readInt();
        Rolk.boost     =myDataInputStream.readFloat();
        Control.upd=Control.clk+1.0;
        for (c1=Marsokhod.PUSH;c1<=Marsokhod.ELEB;c1++)
          Marsokhod.myControl[c1].VD=myDataInputStream.readFloat();
        recv=true;
      } else
        System.out.println("hdr!");
    }
    if (recv) { // 8+4*(2+5*8+9)
      nyByteArrayOutputStream.reset();
      nyDataOutputStream.writeInt(HDR);                                             // 4
      nyDataOutputStream.writeDouble(Control.clk);                                  // 8
      nyDataOutputStream.writeFloat((float)Control.dlt);                            // 4
      for (c1=0;c1<8;c1++) {                                                        //
        nyDataOutputStream.writeFloat((float)Marsokhod.pos[c1]);                    // 4
        nyDataOutputStream.writeFloat((float)Marsokhod.bcl[c1]);                    // 4
        nyDataOutputStream.writeFloat((float)Marsokhod.vel[c1]);                    // 4
        nyDataOutputStream.writeFloat((float)Marsokhod.lod[c1]);                    // 4
        nyDataOutputStream.writeInt(Marsokhod.pwm[c1]);                             // 4
      }                                                                             //
      nyDataOutputStream.writeFloat((float)Marsokhod.vcc   );                       // 4
      nyDataOutputStream.writeFloat((float)Marsokhod.VCC   );                       // 4
      nyDataOutputStream.writeFloat((float)Marsokhod.gyr   );                       // 4
      nyDataOutputStream.writeFloat((float)Marsokhod.grv[0]);                       // 4
      nyDataOutputStream.writeFloat((float)Marsokhod.grv[1]);                       // 4
      nyDataOutputStream.writeFloat((float)Marsokhod.grv[2]);                       // 4
      nyDataOutputStream.writeFloat((float)Marsokhod.myControl[Marsokhod.PUSH].dd); // 4
      nyDataOutputStream.writeFloat((float)Marsokhod.myControl[Marsokhod.ELEF].ei); // 4
      nyDataOutputStream.writeFloat((float)Marsokhod.myControl[Marsokhod.ELEB].ei); // 4
      nyDataOutputStream.flush();
      byte[] myByte=nyByteArrayOutputStream.toByteArray();
      myDataOutputStream.write(myByte,0,myByte.length);
      myDataOutputStream.flush();
    }
  }
  
  static public void open() throws IOException {
    mySocket=new Socket(InetAddress.getByName(IP),TC);
    myDataInputStream=new DataInputStream(mySocket.getInputStream());
    myDataOutputStream=new DataOutputStream(mySocket.getOutputStream());
    nyDataOutputStream=new DataOutputStream(nyByteArrayOutputStream);
  }
  
  static public void close() throws IOException {
    mySocket.close();
	}
  
}
