// code by jph

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;

public class Status {
  static final int WIDTH=550;
  static final int HEIGHT=130;  
  static final int SZE=4;  
  static final String[] TITLE={""," pos"," vel"," load"};
  
  static final int BCL=8;
  static final int VEL=16; 
  static final int LOD=24;
  
  static JToggleButton myJToggleButton;
  static JLabel[] myJLabel;
  static JLabel myJLabel_clk;
  static JLabel myJLabel_vcc;
  static JLabel myJLabel_sla;
  static JLabel myJLabel_gyr;
  static JTextField myJTextField;	
	static DataOutputStream myDataOutputStream;
	
  static public void init() {
    int c1;
    JFrame myJFrame=new JFrame("Status ["+new Date()+"]");
    Container myContainer=new Container();
    myContainer.setLayout(new BorderLayout());
    
		JPanel myJPanel;
    myJPanel=new JPanel();
    myJPanel.setLayout(new BorderLayout());
		
    JToolBar myJToolBar;
    myJToolBar=new JToolBar();
    myJToolBar.add(myJLabel_clk=new JLabel("",new ImageIcon("res/icon.sgl.gif"),JLabel.LEFT));
    myJToolBar.add(myJLabel_vcc=new JLabel("",new ImageIcon("res/icon.pow.gif"),JLabel.LEFT));
    myJToolBar.add(myJLabel_sla=new JLabel("",new ImageIcon("res/icon.jus.gif"),JLabel.LEFT));
    myJToolBar.add(myJLabel_gyr=new JLabel("",new ImageIcon("res/icon.ara.png"),JLabel.LEFT));
    myJLabel_sla.setFont(new Font("Courier",Font.PLAIN,12));
    myJLabel_gyr.setFont(new Font("Courier",Font.PLAIN,12));
    myJToolBar.setFloatable(false);
    myJPanel.add(myJToolBar,"Center");    
    
    myJToolBar=new JToolBar();
    myJTextField=new JTextField("noname",11);
    myJToolBar.add(myJTextField);
    myJToggleButton=new JToggleButton("",new ImageIcon("res/icon.rcb.gif"));
    myJToggleButton.setToolTipText("toggle recording");
    myJToggleButton.addActionListener(
      new ActionListener() {
        public void actionPerformed(ActionEvent myActionEvent) {
          if (myJToggleButton.isSelected()) {
            try {
              myDataOutputStream=new DataOutputStream(new FileOutputStream("../log/status"+System.currentTimeMillis()+"."+myJTextField.getText()+".bin"));
            } catch (Exception myException) {
              System.out.println(myException);
            }
          } else {
            try {
              myDataOutputStream.close();
            } catch (Exception myException) {
              System.out.println(myException);
            } 
            myDataOutputStream=null;
          }
        }
      }
    );
    myDataOutputStream=null;
    myJToolBar.add(myJToggleButton);
    myJToolBar.setFloatable(false);
    myJPanel.add(myJToolBar,"East");
    myContainer.add("North",myJPanel);		
    
    myJPanel=new JPanel();
    myJPanel.setLayout(new GridLayout(SZE,8));
    myJLabel=new JLabel[SZE*8];
    for (c1=0;c1<myJLabel.length;c1++) {
      myJLabel[c1]=new JLabel("",JLabel.CENTER);
      myJLabel[c1].setOpaque(true);
      myJPanel.add(myJLabel[c1]);
    }
    for (c1=0;c1<8;c1++)
      myJLabel[c1].setText(Marsokhod.MID[c1]);
    myContainer.add("Center",myJPanel);
    
    myJPanel=new JPanel();
    myJPanel.setLayout(new GridLayout(SZE,1));
    for (c1=0;c1<SZE;c1++) 
      myJPanel.add(new JLabel(TITLE[c1]));
    myContainer.add("West",myJPanel);
    
    myJFrame.getContentPane().add(myContainer);
    myJFrame.setLocation(0,0);
    myJFrame.setSize(WIDTH,HEIGHT);
    myJFrame.setVisible(true);    
  }
  
  static void refresh() {
    int c1,c2;
    int clk=(int)(Control.clk*1000);
    int clk_ms=clk%1000;
    clk/=1000;
    int clk_s =clk%60;
    clk/=60;
    int clk_m =clk;
    myJLabel_clk.setText(String.format("%02d:%02d:%03d %4.1f ms   ",clk_m,clk_s,clk_ms,Control.dlt*1000));
    myJLabel_vcc.setText(String.format("%4.1f (%4.1f) V   ",Marsokhod.vcc,Marsokhod.VCC));
    myJLabel_sla.setText(String.format("%+4.1f ",Marsokhod.SLA()*57.2958));
    myJLabel_gyr.setText(String.format("%+4.1f/s",Marsokhod.gyr*57.2958));
    int col;
    for (c1=0;c1<8;c1++) {
      myJLabel[BCL+c1].setText(String.format("%6.3f",Marsokhod.bcl[c1]));
      myJLabel[VEL+c1].setText(String.format("%6.3f",Marsokhod.vel[c1]));
      if (0<Marsokhod.vel[c1]) {
        col=Math.min((int)Math.round( 255*Marsokhod.vel[c1]/Marsokhod.VEL),255);
        myJLabel[VEL+c1].setBackground(new Color(255-col,255,255-col));
      } else {
        col=Math.min((int)Math.round(-255*Marsokhod.vel[c1]/Marsokhod.VEL),255);
        myJLabel[VEL+c1].setBackground(new Color(255,255-col,255));
      }
      myJLabel[LOD+c1].setText(String.format("%6.3f",Marsokhod.lod[c1]));
      if (0<Marsokhod.lod[c1]) {
        col=Math.min((int)Math.round( Marsokhod.lod[c1]*600),255);
        myJLabel[LOD+c1].setBackground(new Color(255,255-col,255-col));
      } else {
        col=Math.min((int)Math.round(-Marsokhod.lod[c1]*600),255);
        myJLabel[LOD+c1].setBackground(new Color(255-col,255-col,255));
      }
    }
    
    if (myDataOutputStream!=null) {
      try {
        for (c1=0;c1<8;++c1) {
          myDataOutputStream.writeDouble(Marsokhod.pos[c1]);
          myDataOutputStream.writeDouble(Marsokhod.vel[c1]);
          myDataOutputStream.writeDouble(Marsokhod.vex[c1]);
          myDataOutputStream.writeDouble(Marsokhod.pwm[c1]);
          myDataOutputStream.writeDouble(Marsokhod.lod[c1]);
          myDataOutputStream.writeDouble(Marsokhod.ral[c1]);
        }
        myDataOutputStream.writeDouble(Control.clk);
        myDataOutputStream.writeDouble(Marsokhod.vcc);
        myDataOutputStream.writeDouble(Marsokhod.VCC);
        myDataOutputStream.writeDouble(Marsokhod.thr);
        myDataOutputStream.writeDouble(Marsokhod.gyr);
        myDataOutputStream.writeDouble(Marsokhod.grv[0]);
        myDataOutputStream.writeDouble(Marsokhod.grv[1]);
        myDataOutputStream.writeDouble(Marsokhod.grv[2]);
        myDataOutputStream.writeDouble(Marsokhod.tlt[0]);
        myDataOutputStream.writeDouble(Marsokhod.tlt[1]);
        myDataOutputStream.writeDouble(Marsokhod.bcl[6]);
        myDataOutputStream.writeDouble(Marsokhod.bcl[7]);
        myDataOutputStream.writeDouble(Marsokhod.BCL(6));
        myDataOutputStream.writeDouble(Marsokhod.BCL(7));        
      } catch (Exception myException) {
        myDataOutputStream=null;
      }
    }
  }  
}
